
#include "Switch1616.hpp"

struct Switch1616Widget : SwitchMatrixModuleWidget {
	static constexpr int hp = 22;

	Switch1616Widget(Switch1616* module) {
		setModule(module);
		box.size = Vec(RACK_GRID_WIDTH * hp, RACK_GRID_HEIGHT);
		setPanel(box.size, "Switch1616");
		createScrews();

		// generated by svg_widgets.rb
		auto mix11ParamPosition = Vec(85.0, 35.0);
		auto mix12ParamPosition = Vec(85.0, 50.0);
		auto mix13ParamPosition = Vec(85.0, 65.0);
		auto mix14ParamPosition = Vec(85.0, 80.0);
		auto mix15ParamPosition = Vec(85.0, 95.0);
		auto mix16ParamPosition = Vec(85.0, 110.0);
		auto mix17ParamPosition = Vec(85.0, 125.0);
		auto mix18ParamPosition = Vec(85.0, 140.0);
		auto mix19ParamPosition = Vec(85.0, 155.0);
		auto mix110ParamPosition = Vec(85.0, 170.0);
		auto mix1_11ParamPosition = Vec(85.0, 185.0);
		auto mix1_12ParamPosition = Vec(85.0, 200.0);
		auto mix1_13ParamPosition = Vec(85.0, 215.0);
		auto mix1_14ParamPosition = Vec(85.0, 230.0);
		auto mix1_15ParamPosition = Vec(85.0, 245.0);
		auto mix1_16ParamPosition = Vec(85.0, 260.0);
		auto mix21ParamPosition = Vec(100.0, 35.0);
		auto mix22ParamPosition = Vec(100.0, 50.0);
		auto mix23ParamPosition = Vec(100.0, 65.0);
		auto mix24ParamPosition = Vec(100.0, 80.0);
		auto mix25ParamPosition = Vec(100.0, 95.0);
		auto mix26ParamPosition = Vec(100.0, 110.0);
		auto mix27ParamPosition = Vec(100.0, 125.0);
		auto mix28ParamPosition = Vec(100.0, 140.0);
		auto mix29ParamPosition = Vec(100.0, 155.0);
		auto mix210ParamPosition = Vec(100.0, 170.0);
		auto mix211ParamPosition = Vec(100.0, 185.0);
		auto mix212ParamPosition = Vec(100.0, 200.0);
		auto mix213ParamPosition = Vec(100.0, 215.0);
		auto mix214ParamPosition = Vec(100.0, 230.0);
		auto mix215ParamPosition = Vec(100.0, 245.0);
		auto mix216ParamPosition = Vec(100.0, 260.0);
		auto mix31ParamPosition = Vec(115.0, 35.0);
		auto mix32ParamPosition = Vec(115.0, 50.0);
		auto mix33ParamPosition = Vec(115.0, 65.0);
		auto mix34ParamPosition = Vec(115.0, 80.0);
		auto mix35ParamPosition = Vec(115.0, 95.0);
		auto mix36ParamPosition = Vec(115.0, 110.0);
		auto mix37ParamPosition = Vec(115.0, 125.0);
		auto mix38ParamPosition = Vec(115.0, 140.0);
		auto mix39ParamPosition = Vec(115.0, 155.0);
		auto mix310ParamPosition = Vec(115.0, 170.0);
		auto mix311ParamPosition = Vec(115.0, 185.0);
		auto mix312ParamPosition = Vec(115.0, 200.0);
		auto mix313ParamPosition = Vec(115.0, 215.0);
		auto mix314ParamPosition = Vec(115.0, 230.0);
		auto mix315ParamPosition = Vec(115.0, 245.0);
		auto mix316ParamPosition = Vec(115.0, 260.0);
		auto mix41ParamPosition = Vec(130.0, 35.0);
		auto mix42ParamPosition = Vec(130.0, 50.0);
		auto mix43ParamPosition = Vec(130.0, 65.0);
		auto mix44ParamPosition = Vec(130.0, 80.0);
		auto mix45ParamPosition = Vec(130.0, 95.0);
		auto mix46ParamPosition = Vec(130.0, 110.0);
		auto mix47ParamPosition = Vec(130.0, 125.0);
		auto mix48ParamPosition = Vec(130.0, 140.0);
		auto mix49ParamPosition = Vec(130.0, 155.0);
		auto mix410ParamPosition = Vec(130.0, 170.0);
		auto mix411ParamPosition = Vec(130.0, 185.0);
		auto mix412ParamPosition = Vec(130.0, 200.0);
		auto mix413ParamPosition = Vec(130.0, 215.0);
		auto mix414ParamPosition = Vec(130.0, 230.0);
		auto mix415ParamPosition = Vec(130.0, 245.0);
		auto mix416ParamPosition = Vec(130.0, 260.0);
		auto mix51ParamPosition = Vec(145.0, 35.0);
		auto mix52ParamPosition = Vec(145.0, 50.0);
		auto mix53ParamPosition = Vec(145.0, 65.0);
		auto mix54ParamPosition = Vec(145.0, 80.0);
		auto mix55ParamPosition = Vec(145.0, 95.0);
		auto mix56ParamPosition = Vec(145.0, 110.0);
		auto mix57ParamPosition = Vec(145.0, 125.0);
		auto mix58ParamPosition = Vec(145.0, 140.0);
		auto mix59ParamPosition = Vec(145.0, 155.0);
		auto mix510ParamPosition = Vec(145.0, 170.0);
		auto mix511ParamPosition = Vec(145.0, 185.0);
		auto mix512ParamPosition = Vec(145.0, 200.0);
		auto mix513ParamPosition = Vec(145.0, 215.0);
		auto mix514ParamPosition = Vec(145.0, 230.0);
		auto mix515ParamPosition = Vec(145.0, 245.0);
		auto mix516ParamPosition = Vec(145.0, 260.0);
		auto mix61ParamPosition = Vec(160.0, 35.0);
		auto mix62ParamPosition = Vec(160.0, 50.0);
		auto mix63ParamPosition = Vec(160.0, 65.0);
		auto mix64ParamPosition = Vec(160.0, 80.0);
		auto mix65ParamPosition = Vec(160.0, 95.0);
		auto mix66ParamPosition = Vec(160.0, 110.0);
		auto mix67ParamPosition = Vec(160.0, 125.0);
		auto mix68ParamPosition = Vec(160.0, 140.0);
		auto mix69ParamPosition = Vec(160.0, 155.0);
		auto mix610ParamPosition = Vec(160.0, 170.0);
		auto mix611ParamPosition = Vec(160.0, 185.0);
		auto mix612ParamPosition = Vec(160.0, 200.0);
		auto mix613ParamPosition = Vec(160.0, 215.0);
		auto mix614ParamPosition = Vec(160.0, 230.0);
		auto mix615ParamPosition = Vec(160.0, 245.0);
		auto mix616ParamPosition = Vec(160.0, 260.0);
		auto mix71ParamPosition = Vec(175.0, 35.0);
		auto mix72ParamPosition = Vec(175.0, 50.0);
		auto mix73ParamPosition = Vec(175.0, 65.0);
		auto mix74ParamPosition = Vec(175.0, 80.0);
		auto mix75ParamPosition = Vec(175.0, 95.0);
		auto mix76ParamPosition = Vec(175.0, 110.0);
		auto mix77ParamPosition = Vec(175.0, 125.0);
		auto mix78ParamPosition = Vec(175.0, 140.0);
		auto mix79ParamPosition = Vec(175.0, 155.0);
		auto mix710ParamPosition = Vec(175.0, 170.0);
		auto mix711ParamPosition = Vec(175.0, 185.0);
		auto mix712ParamPosition = Vec(175.0, 200.0);
		auto mix713ParamPosition = Vec(175.0, 215.0);
		auto mix714ParamPosition = Vec(175.0, 230.0);
		auto mix715ParamPosition = Vec(175.0, 245.0);
		auto mix716ParamPosition = Vec(175.0, 260.0);
		auto mix81ParamPosition = Vec(190.0, 35.0);
		auto mix82ParamPosition = Vec(190.0, 50.0);
		auto mix83ParamPosition = Vec(190.0, 65.0);
		auto mix84ParamPosition = Vec(190.0, 80.0);
		auto mix85ParamPosition = Vec(190.0, 95.0);
		auto mix86ParamPosition = Vec(190.0, 110.0);
		auto mix87ParamPosition = Vec(190.0, 125.0);
		auto mix88ParamPosition = Vec(190.0, 140.0);
		auto mix89ParamPosition = Vec(190.0, 155.0);
		auto mix810ParamPosition = Vec(190.0, 170.0);
		auto mix811ParamPosition = Vec(190.0, 185.0);
		auto mix812ParamPosition = Vec(190.0, 200.0);
		auto mix813ParamPosition = Vec(190.0, 215.0);
		auto mix814ParamPosition = Vec(190.0, 230.0);
		auto mix815ParamPosition = Vec(190.0, 245.0);
		auto mix816ParamPosition = Vec(190.0, 260.0);
		auto mix91ParamPosition = Vec(205.0, 35.0);
		auto mix92ParamPosition = Vec(205.0, 50.0);
		auto mix93ParamPosition = Vec(205.0, 65.0);
		auto mix94ParamPosition = Vec(205.0, 80.0);
		auto mix95ParamPosition = Vec(205.0, 95.0);
		auto mix96ParamPosition = Vec(205.0, 110.0);
		auto mix97ParamPosition = Vec(205.0, 125.0);
		auto mix98ParamPosition = Vec(205.0, 140.0);
		auto mix99ParamPosition = Vec(205.0, 155.0);
		auto mix910ParamPosition = Vec(205.0, 170.0);
		auto mix911ParamPosition = Vec(205.0, 185.0);
		auto mix912ParamPosition = Vec(205.0, 200.0);
		auto mix913ParamPosition = Vec(205.0, 215.0);
		auto mix914ParamPosition = Vec(205.0, 230.0);
		auto mix915ParamPosition = Vec(205.0, 245.0);
		auto mix916ParamPosition = Vec(205.0, 260.0);
		auto mix101ParamPosition = Vec(220.0, 35.0);
		auto mix102ParamPosition = Vec(220.0, 50.0);
		auto mix103ParamPosition = Vec(220.0, 65.0);
		auto mix104ParamPosition = Vec(220.0, 80.0);
		auto mix105ParamPosition = Vec(220.0, 95.0);
		auto mix106ParamPosition = Vec(220.0, 110.0);
		auto mix107ParamPosition = Vec(220.0, 125.0);
		auto mix108ParamPosition = Vec(220.0, 140.0);
		auto mix109ParamPosition = Vec(220.0, 155.0);
		auto mix1010ParamPosition = Vec(220.0, 170.0);
		auto mix1011ParamPosition = Vec(220.0, 185.0);
		auto mix1012ParamPosition = Vec(220.0, 200.0);
		auto mix1013ParamPosition = Vec(220.0, 215.0);
		auto mix1014ParamPosition = Vec(220.0, 230.0);
		auto mix1015ParamPosition = Vec(220.0, 245.0);
		auto mix1016ParamPosition = Vec(220.0, 260.0);
		auto mix111ParamPosition = Vec(235.0, 35.0);
		auto mix112ParamPosition = Vec(235.0, 50.0);
		auto mix113ParamPosition = Vec(235.0, 65.0);
		auto mix114ParamPosition = Vec(235.0, 80.0);
		auto mix115ParamPosition = Vec(235.0, 95.0);
		auto mix116ParamPosition = Vec(235.0, 110.0);
		auto mix117ParamPosition = Vec(235.0, 125.0);
		auto mix118ParamPosition = Vec(235.0, 140.0);
		auto mix119ParamPosition = Vec(235.0, 155.0);
		auto mix1110ParamPosition = Vec(235.0, 170.0);
		auto mix1111ParamPosition = Vec(235.0, 185.0);
		auto mix1112ParamPosition = Vec(235.0, 200.0);
		auto mix1113ParamPosition = Vec(235.0, 215.0);
		auto mix1114ParamPosition = Vec(235.0, 230.0);
		auto mix1115ParamPosition = Vec(235.0, 245.0);
		auto mix1116ParamPosition = Vec(235.0, 260.0);
		auto mix121ParamPosition = Vec(250.0, 35.0);
		auto mix122ParamPosition = Vec(250.0, 50.0);
		auto mix123ParamPosition = Vec(250.0, 65.0);
		auto mix124ParamPosition = Vec(250.0, 80.0);
		auto mix125ParamPosition = Vec(250.0, 95.0);
		auto mix126ParamPosition = Vec(250.0, 110.0);
		auto mix127ParamPosition = Vec(250.0, 125.0);
		auto mix128ParamPosition = Vec(250.0, 140.0);
		auto mix129ParamPosition = Vec(250.0, 155.0);
		auto mix1210ParamPosition = Vec(250.0, 170.0);
		auto mix1211ParamPosition = Vec(250.0, 185.0);
		auto mix1212ParamPosition = Vec(250.0, 200.0);
		auto mix1213ParamPosition = Vec(250.0, 215.0);
		auto mix1214ParamPosition = Vec(250.0, 230.0);
		auto mix1215ParamPosition = Vec(250.0, 245.0);
		auto mix1216ParamPosition = Vec(250.0, 260.0);
		auto mix131ParamPosition = Vec(265.0, 35.0);
		auto mix132ParamPosition = Vec(265.0, 50.0);
		auto mix133ParamPosition = Vec(265.0, 65.0);
		auto mix134ParamPosition = Vec(265.0, 80.0);
		auto mix135ParamPosition = Vec(265.0, 95.0);
		auto mix136ParamPosition = Vec(265.0, 110.0);
		auto mix137ParamPosition = Vec(265.0, 125.0);
		auto mix138ParamPosition = Vec(265.0, 140.0);
		auto mix139ParamPosition = Vec(265.0, 155.0);
		auto mix1310ParamPosition = Vec(265.0, 170.0);
		auto mix1311ParamPosition = Vec(265.0, 185.0);
		auto mix1312ParamPosition = Vec(265.0, 200.0);
		auto mix1313ParamPosition = Vec(265.0, 215.0);
		auto mix1314ParamPosition = Vec(265.0, 230.0);
		auto mix1315ParamPosition = Vec(265.0, 245.0);
		auto mix1316ParamPosition = Vec(265.0, 260.0);
		auto mix141ParamPosition = Vec(280.0, 35.0);
		auto mix142ParamPosition = Vec(280.0, 50.0);
		auto mix143ParamPosition = Vec(280.0, 65.0);
		auto mix144ParamPosition = Vec(280.0, 80.0);
		auto mix145ParamPosition = Vec(280.0, 95.0);
		auto mix146ParamPosition = Vec(280.0, 110.0);
		auto mix147ParamPosition = Vec(280.0, 125.0);
		auto mix148ParamPosition = Vec(280.0, 140.0);
		auto mix149ParamPosition = Vec(280.0, 155.0);
		auto mix1410ParamPosition = Vec(280.0, 170.0);
		auto mix1411ParamPosition = Vec(280.0, 185.0);
		auto mix1412ParamPosition = Vec(280.0, 200.0);
		auto mix1413ParamPosition = Vec(280.0, 215.0);
		auto mix1414ParamPosition = Vec(280.0, 230.0);
		auto mix1415ParamPosition = Vec(280.0, 245.0);
		auto mix1416ParamPosition = Vec(280.0, 260.0);
		auto mix151ParamPosition = Vec(295.0, 35.0);
		auto mix152ParamPosition = Vec(295.0, 50.0);
		auto mix153ParamPosition = Vec(295.0, 65.0);
		auto mix154ParamPosition = Vec(295.0, 80.0);
		auto mix155ParamPosition = Vec(295.0, 95.0);
		auto mix156ParamPosition = Vec(295.0, 110.0);
		auto mix157ParamPosition = Vec(295.0, 125.0);
		auto mix158ParamPosition = Vec(295.0, 140.0);
		auto mix159ParamPosition = Vec(295.0, 155.0);
		auto mix1510ParamPosition = Vec(295.0, 170.0);
		auto mix1511ParamPosition = Vec(295.0, 185.0);
		auto mix1512ParamPosition = Vec(295.0, 200.0);
		auto mix1513ParamPosition = Vec(295.0, 215.0);
		auto mix1514ParamPosition = Vec(295.0, 230.0);
		auto mix1515ParamPosition = Vec(295.0, 245.0);
		auto mix1516ParamPosition = Vec(295.0, 260.0);
		auto mix161ParamPosition = Vec(310.0, 35.0);
		auto mix162ParamPosition = Vec(310.0, 50.0);
		auto mix163ParamPosition = Vec(310.0, 65.0);
		auto mix164ParamPosition = Vec(310.0, 80.0);
		auto mix165ParamPosition = Vec(310.0, 95.0);
		auto mix166ParamPosition = Vec(310.0, 110.0);
		auto mix167ParamPosition = Vec(310.0, 125.0);
		auto mix168ParamPosition = Vec(310.0, 140.0);
		auto mix169ParamPosition = Vec(310.0, 155.0);
		auto mix1610ParamPosition = Vec(310.0, 170.0);
		auto mix1611ParamPosition = Vec(310.0, 185.0);
		auto mix1612ParamPosition = Vec(310.0, 200.0);
		auto mix1613ParamPosition = Vec(310.0, 215.0);
		auto mix1614ParamPosition = Vec(310.0, 230.0);
		auto mix1615ParamPosition = Vec(310.0, 245.0);
		auto mix1616ParamPosition = Vec(310.0, 260.0);

		auto in2InputPosition = Vec(9.5, 31.0);
		auto in4InputPosition = Vec(9.5, 67.0);
		auto in6InputPosition = Vec(9.5, 103.0);
		auto in8InputPosition = Vec(9.5, 139.0);
		auto in10InputPosition = Vec(9.5, 175.0);
		auto in12InputPosition = Vec(9.5, 211.0);
		auto in14InputPosition = Vec(9.5, 247.0);
		auto in16InputPosition = Vec(9.5, 283.0);
		auto in1InputPosition = Vec(33.5, 13.0);
		auto in3InputPosition = Vec(33.5, 49.0);
		auto in5InputPosition = Vec(33.5, 85.0);
		auto in7InputPosition = Vec(33.5, 121.0);
		auto in9InputPosition = Vec(33.5, 157.0);
		auto in11InputPosition = Vec(33.5, 193.0);
		auto in13InputPosition = Vec(33.5, 229.0);
		auto in15InputPosition = Vec(33.5, 265.0);

		auto out1OutputPosition = Vec(26.5, 330.0);
		auto out3OutputPosition = Vec(62.5, 330.0);
		auto out5OutputPosition = Vec(98.5, 330.0);
		auto out7OutputPosition = Vec(134.5, 330.0);
		auto out9OutputPosition = Vec(170.5, 330.0);
		auto out11OutputPosition = Vec(206.5, 330.0);
		auto out13OutputPosition = Vec(242.5, 330.0);
		auto out15OutputPosition = Vec(278.5, 330.0);
		auto out2OutputPosition = Vec(44.5, 306.0);
		auto out4OutputPosition = Vec(80.5, 306.0);
		auto out6OutputPosition = Vec(116.5, 306.0);
		auto out8OutputPosition = Vec(152.5, 306.0);
		auto out10OutputPosition = Vec(188.5, 306.0);
		auto out12OutputPosition = Vec(224.5, 306.0);
		auto out14OutputPosition = Vec(260.5, 306.0);
		auto out16OutputPosition = Vec(296.5, 306.0);
		// end generated by svg_widgets.rb

		createSwitch<InvertingIndicatorButton9>(mix11ParamPosition, module, Switch1616::MIX_1_1_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix12ParamPosition, module, Switch1616::MIX_1_2_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix13ParamPosition, module, Switch1616::MIX_1_3_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix14ParamPosition, module, Switch1616::MIX_1_4_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix15ParamPosition, module, Switch1616::MIX_1_5_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix16ParamPosition, module, Switch1616::MIX_1_6_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix17ParamPosition, module, Switch1616::MIX_1_7_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix18ParamPosition, module, Switch1616::MIX_1_8_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix19ParamPosition, module, Switch1616::MIX_1_9_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix110ParamPosition, module, Switch1616::MIX_1_10_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1_11ParamPosition, module, Switch1616::MIX_1_11_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1_12ParamPosition, module, Switch1616::MIX_1_12_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1_13ParamPosition, module, Switch1616::MIX_1_13_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1_14ParamPosition, module, Switch1616::MIX_1_14_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1_15ParamPosition, module, Switch1616::MIX_1_15_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1_16ParamPosition, module, Switch1616::MIX_1_16_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix21ParamPosition, module, Switch1616::MIX_2_1_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix22ParamPosition, module, Switch1616::MIX_2_2_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix23ParamPosition, module, Switch1616::MIX_2_3_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix24ParamPosition, module, Switch1616::MIX_2_4_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix25ParamPosition, module, Switch1616::MIX_2_5_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix26ParamPosition, module, Switch1616::MIX_2_6_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix27ParamPosition, module, Switch1616::MIX_2_7_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix28ParamPosition, module, Switch1616::MIX_2_8_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix29ParamPosition, module, Switch1616::MIX_2_9_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix210ParamPosition, module, Switch1616::MIX_2_10_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix211ParamPosition, module, Switch1616::MIX_2_11_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix212ParamPosition, module, Switch1616::MIX_2_12_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix213ParamPosition, module, Switch1616::MIX_2_13_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix214ParamPosition, module, Switch1616::MIX_2_14_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix215ParamPosition, module, Switch1616::MIX_2_15_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix216ParamPosition, module, Switch1616::MIX_2_16_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix31ParamPosition, module, Switch1616::MIX_3_1_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix32ParamPosition, module, Switch1616::MIX_3_2_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix33ParamPosition, module, Switch1616::MIX_3_3_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix34ParamPosition, module, Switch1616::MIX_3_4_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix35ParamPosition, module, Switch1616::MIX_3_5_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix36ParamPosition, module, Switch1616::MIX_3_6_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix37ParamPosition, module, Switch1616::MIX_3_7_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix38ParamPosition, module, Switch1616::MIX_3_8_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix39ParamPosition, module, Switch1616::MIX_3_9_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix310ParamPosition, module, Switch1616::MIX_3_10_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix311ParamPosition, module, Switch1616::MIX_3_11_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix312ParamPosition, module, Switch1616::MIX_3_12_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix313ParamPosition, module, Switch1616::MIX_3_13_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix314ParamPosition, module, Switch1616::MIX_3_14_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix315ParamPosition, module, Switch1616::MIX_3_15_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix316ParamPosition, module, Switch1616::MIX_3_16_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix41ParamPosition, module, Switch1616::MIX_4_1_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix42ParamPosition, module, Switch1616::MIX_4_2_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix43ParamPosition, module, Switch1616::MIX_4_3_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix44ParamPosition, module, Switch1616::MIX_4_4_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix45ParamPosition, module, Switch1616::MIX_4_5_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix46ParamPosition, module, Switch1616::MIX_4_6_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix47ParamPosition, module, Switch1616::MIX_4_7_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix48ParamPosition, module, Switch1616::MIX_4_8_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix49ParamPosition, module, Switch1616::MIX_4_9_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix410ParamPosition, module, Switch1616::MIX_4_10_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix411ParamPosition, module, Switch1616::MIX_4_11_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix412ParamPosition, module, Switch1616::MIX_4_12_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix413ParamPosition, module, Switch1616::MIX_4_13_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix414ParamPosition, module, Switch1616::MIX_4_14_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix415ParamPosition, module, Switch1616::MIX_4_15_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix416ParamPosition, module, Switch1616::MIX_4_16_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix51ParamPosition, module, Switch1616::MIX_5_1_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix52ParamPosition, module, Switch1616::MIX_5_2_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix53ParamPosition, module, Switch1616::MIX_5_3_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix54ParamPosition, module, Switch1616::MIX_5_4_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix55ParamPosition, module, Switch1616::MIX_5_5_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix56ParamPosition, module, Switch1616::MIX_5_6_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix57ParamPosition, module, Switch1616::MIX_5_7_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix58ParamPosition, module, Switch1616::MIX_5_8_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix59ParamPosition, module, Switch1616::MIX_5_9_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix510ParamPosition, module, Switch1616::MIX_5_10_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix511ParamPosition, module, Switch1616::MIX_5_11_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix512ParamPosition, module, Switch1616::MIX_5_12_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix513ParamPosition, module, Switch1616::MIX_5_13_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix514ParamPosition, module, Switch1616::MIX_5_14_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix515ParamPosition, module, Switch1616::MIX_5_15_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix516ParamPosition, module, Switch1616::MIX_5_16_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix61ParamPosition, module, Switch1616::MIX_6_1_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix62ParamPosition, module, Switch1616::MIX_6_2_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix63ParamPosition, module, Switch1616::MIX_6_3_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix64ParamPosition, module, Switch1616::MIX_6_4_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix65ParamPosition, module, Switch1616::MIX_6_5_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix66ParamPosition, module, Switch1616::MIX_6_6_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix67ParamPosition, module, Switch1616::MIX_6_7_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix68ParamPosition, module, Switch1616::MIX_6_8_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix69ParamPosition, module, Switch1616::MIX_6_9_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix610ParamPosition, module, Switch1616::MIX_6_10_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix611ParamPosition, module, Switch1616::MIX_6_11_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix612ParamPosition, module, Switch1616::MIX_6_12_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix613ParamPosition, module, Switch1616::MIX_6_13_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix614ParamPosition, module, Switch1616::MIX_6_14_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix615ParamPosition, module, Switch1616::MIX_6_15_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix616ParamPosition, module, Switch1616::MIX_6_16_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix71ParamPosition, module, Switch1616::MIX_7_1_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix72ParamPosition, module, Switch1616::MIX_7_2_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix73ParamPosition, module, Switch1616::MIX_7_3_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix74ParamPosition, module, Switch1616::MIX_7_4_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix75ParamPosition, module, Switch1616::MIX_7_5_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix76ParamPosition, module, Switch1616::MIX_7_6_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix77ParamPosition, module, Switch1616::MIX_7_7_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix78ParamPosition, module, Switch1616::MIX_7_8_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix79ParamPosition, module, Switch1616::MIX_7_9_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix710ParamPosition, module, Switch1616::MIX_7_10_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix711ParamPosition, module, Switch1616::MIX_7_11_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix712ParamPosition, module, Switch1616::MIX_7_12_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix713ParamPosition, module, Switch1616::MIX_7_13_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix714ParamPosition, module, Switch1616::MIX_7_14_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix715ParamPosition, module, Switch1616::MIX_7_15_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix716ParamPosition, module, Switch1616::MIX_7_16_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix81ParamPosition, module, Switch1616::MIX_8_1_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix82ParamPosition, module, Switch1616::MIX_8_2_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix83ParamPosition, module, Switch1616::MIX_8_3_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix84ParamPosition, module, Switch1616::MIX_8_4_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix85ParamPosition, module, Switch1616::MIX_8_5_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix86ParamPosition, module, Switch1616::MIX_8_6_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix87ParamPosition, module, Switch1616::MIX_8_7_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix88ParamPosition, module, Switch1616::MIX_8_8_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix89ParamPosition, module, Switch1616::MIX_8_9_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix810ParamPosition, module, Switch1616::MIX_8_10_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix811ParamPosition, module, Switch1616::MIX_8_11_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix812ParamPosition, module, Switch1616::MIX_8_12_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix813ParamPosition, module, Switch1616::MIX_8_13_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix814ParamPosition, module, Switch1616::MIX_8_14_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix815ParamPosition, module, Switch1616::MIX_8_15_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix816ParamPosition, module, Switch1616::MIX_8_16_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix91ParamPosition, module, Switch1616::MIX_9_1_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix92ParamPosition, module, Switch1616::MIX_9_2_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix93ParamPosition, module, Switch1616::MIX_9_3_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix94ParamPosition, module, Switch1616::MIX_9_4_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix95ParamPosition, module, Switch1616::MIX_9_5_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix96ParamPosition, module, Switch1616::MIX_9_6_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix97ParamPosition, module, Switch1616::MIX_9_7_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix98ParamPosition, module, Switch1616::MIX_9_8_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix99ParamPosition, module, Switch1616::MIX_9_9_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix910ParamPosition, module, Switch1616::MIX_9_10_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix911ParamPosition, module, Switch1616::MIX_9_11_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix912ParamPosition, module, Switch1616::MIX_9_12_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix913ParamPosition, module, Switch1616::MIX_9_13_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix914ParamPosition, module, Switch1616::MIX_9_14_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix915ParamPosition, module, Switch1616::MIX_9_15_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix916ParamPosition, module, Switch1616::MIX_9_16_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix101ParamPosition, module, Switch1616::MIX_10_1_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix102ParamPosition, module, Switch1616::MIX_10_2_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix103ParamPosition, module, Switch1616::MIX_10_3_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix104ParamPosition, module, Switch1616::MIX_10_4_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix105ParamPosition, module, Switch1616::MIX_10_5_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix106ParamPosition, module, Switch1616::MIX_10_6_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix107ParamPosition, module, Switch1616::MIX_10_7_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix108ParamPosition, module, Switch1616::MIX_10_8_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix109ParamPosition, module, Switch1616::MIX_10_9_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1010ParamPosition, module, Switch1616::MIX_10_10_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1011ParamPosition, module, Switch1616::MIX_10_11_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1012ParamPosition, module, Switch1616::MIX_10_12_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1013ParamPosition, module, Switch1616::MIX_10_13_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1014ParamPosition, module, Switch1616::MIX_10_14_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1015ParamPosition, module, Switch1616::MIX_10_15_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1016ParamPosition, module, Switch1616::MIX_10_16_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix111ParamPosition, module, Switch1616::MIX_11_1_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix112ParamPosition, module, Switch1616::MIX_11_2_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix113ParamPosition, module, Switch1616::MIX_11_3_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix114ParamPosition, module, Switch1616::MIX_11_4_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix115ParamPosition, module, Switch1616::MIX_11_5_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix116ParamPosition, module, Switch1616::MIX_11_6_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix117ParamPosition, module, Switch1616::MIX_11_7_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix118ParamPosition, module, Switch1616::MIX_11_8_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix119ParamPosition, module, Switch1616::MIX_11_9_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1110ParamPosition, module, Switch1616::MIX_11_10_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1111ParamPosition, module, Switch1616::MIX_11_11_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1112ParamPosition, module, Switch1616::MIX_11_12_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1113ParamPosition, module, Switch1616::MIX_11_13_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1114ParamPosition, module, Switch1616::MIX_11_14_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1115ParamPosition, module, Switch1616::MIX_11_15_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1116ParamPosition, module, Switch1616::MIX_11_16_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix121ParamPosition, module, Switch1616::MIX_12_1_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix122ParamPosition, module, Switch1616::MIX_12_2_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix123ParamPosition, module, Switch1616::MIX_12_3_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix124ParamPosition, module, Switch1616::MIX_12_4_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix125ParamPosition, module, Switch1616::MIX_12_5_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix126ParamPosition, module, Switch1616::MIX_12_6_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix127ParamPosition, module, Switch1616::MIX_12_7_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix128ParamPosition, module, Switch1616::MIX_12_8_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix129ParamPosition, module, Switch1616::MIX_12_9_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1210ParamPosition, module, Switch1616::MIX_12_10_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1211ParamPosition, module, Switch1616::MIX_12_11_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1212ParamPosition, module, Switch1616::MIX_12_12_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1213ParamPosition, module, Switch1616::MIX_12_13_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1214ParamPosition, module, Switch1616::MIX_12_14_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1215ParamPosition, module, Switch1616::MIX_12_15_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1216ParamPosition, module, Switch1616::MIX_12_16_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix131ParamPosition, module, Switch1616::MIX_13_1_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix132ParamPosition, module, Switch1616::MIX_13_2_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix133ParamPosition, module, Switch1616::MIX_13_3_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix134ParamPosition, module, Switch1616::MIX_13_4_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix135ParamPosition, module, Switch1616::MIX_13_5_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix136ParamPosition, module, Switch1616::MIX_13_6_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix137ParamPosition, module, Switch1616::MIX_13_7_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix138ParamPosition, module, Switch1616::MIX_13_8_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix139ParamPosition, module, Switch1616::MIX_13_9_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1310ParamPosition, module, Switch1616::MIX_13_10_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1311ParamPosition, module, Switch1616::MIX_13_11_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1312ParamPosition, module, Switch1616::MIX_13_12_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1313ParamPosition, module, Switch1616::MIX_13_13_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1314ParamPosition, module, Switch1616::MIX_13_14_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1315ParamPosition, module, Switch1616::MIX_13_15_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1316ParamPosition, module, Switch1616::MIX_13_16_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix141ParamPosition, module, Switch1616::MIX_14_1_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix142ParamPosition, module, Switch1616::MIX_14_2_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix143ParamPosition, module, Switch1616::MIX_14_3_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix144ParamPosition, module, Switch1616::MIX_14_4_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix145ParamPosition, module, Switch1616::MIX_14_5_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix146ParamPosition, module, Switch1616::MIX_14_6_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix147ParamPosition, module, Switch1616::MIX_14_7_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix148ParamPosition, module, Switch1616::MIX_14_8_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix149ParamPosition, module, Switch1616::MIX_14_9_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1410ParamPosition, module, Switch1616::MIX_14_10_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1411ParamPosition, module, Switch1616::MIX_14_11_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1412ParamPosition, module, Switch1616::MIX_14_12_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1413ParamPosition, module, Switch1616::MIX_14_13_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1414ParamPosition, module, Switch1616::MIX_14_14_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1415ParamPosition, module, Switch1616::MIX_14_15_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1416ParamPosition, module, Switch1616::MIX_14_16_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix151ParamPosition, module, Switch1616::MIX_15_1_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix152ParamPosition, module, Switch1616::MIX_15_2_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix153ParamPosition, module, Switch1616::MIX_15_3_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix154ParamPosition, module, Switch1616::MIX_15_4_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix155ParamPosition, module, Switch1616::MIX_15_5_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix156ParamPosition, module, Switch1616::MIX_15_6_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix157ParamPosition, module, Switch1616::MIX_15_7_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix158ParamPosition, module, Switch1616::MIX_15_8_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix159ParamPosition, module, Switch1616::MIX_15_9_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1510ParamPosition, module, Switch1616::MIX_15_10_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1511ParamPosition, module, Switch1616::MIX_15_11_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1512ParamPosition, module, Switch1616::MIX_15_12_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1513ParamPosition, module, Switch1616::MIX_15_13_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1514ParamPosition, module, Switch1616::MIX_15_14_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1515ParamPosition, module, Switch1616::MIX_15_15_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1516ParamPosition, module, Switch1616::MIX_15_16_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix161ParamPosition, module, Switch1616::MIX_16_1_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix162ParamPosition, module, Switch1616::MIX_16_2_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix163ParamPosition, module, Switch1616::MIX_16_3_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix164ParamPosition, module, Switch1616::MIX_16_4_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix165ParamPosition, module, Switch1616::MIX_16_5_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix166ParamPosition, module, Switch1616::MIX_16_6_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix167ParamPosition, module, Switch1616::MIX_16_7_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix168ParamPosition, module, Switch1616::MIX_16_8_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix169ParamPosition, module, Switch1616::MIX_16_9_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1610ParamPosition, module, Switch1616::MIX_16_10_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1611ParamPosition, module, Switch1616::MIX_16_11_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1612ParamPosition, module, Switch1616::MIX_16_12_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1613ParamPosition, module, Switch1616::MIX_16_13_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1614ParamPosition, module, Switch1616::MIX_16_14_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1615ParamPosition, module, Switch1616::MIX_16_15_PARAM);
		createSwitch<InvertingIndicatorButton9>(mix1616ParamPosition, module, Switch1616::MIX_16_16_PARAM);

		addInput(createInput<Port24>(in2InputPosition, module, Switch1616::IN2_INPUT));
		addInput(createInput<Port24>(in4InputPosition, module, Switch1616::IN4_INPUT));
		addInput(createInput<Port24>(in6InputPosition, module, Switch1616::IN6_INPUT));
		addInput(createInput<Port24>(in8InputPosition, module, Switch1616::IN8_INPUT));
		addInput(createInput<Port24>(in10InputPosition, module, Switch1616::IN10_INPUT));
		addInput(createInput<Port24>(in12InputPosition, module, Switch1616::IN12_INPUT));
		addInput(createInput<Port24>(in14InputPosition, module, Switch1616::IN14_INPUT));
		addInput(createInput<Port24>(in16InputPosition, module, Switch1616::IN16_INPUT));
		addInput(createInput<Port24>(in1InputPosition, module, Switch1616::IN1_INPUT));
		addInput(createInput<Port24>(in3InputPosition, module, Switch1616::IN3_INPUT));
		addInput(createInput<Port24>(in5InputPosition, module, Switch1616::IN5_INPUT));
		addInput(createInput<Port24>(in7InputPosition, module, Switch1616::IN7_INPUT));
		addInput(createInput<Port24>(in9InputPosition, module, Switch1616::IN9_INPUT));
		addInput(createInput<Port24>(in11InputPosition, module, Switch1616::IN11_INPUT));
		addInput(createInput<Port24>(in13InputPosition, module, Switch1616::IN13_INPUT));
		addInput(createInput<Port24>(in15InputPosition, module, Switch1616::IN15_INPUT));

		addOutput(createOutput<Port24>(out1OutputPosition, module, Switch1616::OUT1_OUTPUT));
		addOutput(createOutput<Port24>(out3OutputPosition, module, Switch1616::OUT3_OUTPUT));
		addOutput(createOutput<Port24>(out5OutputPosition, module, Switch1616::OUT5_OUTPUT));
		addOutput(createOutput<Port24>(out7OutputPosition, module, Switch1616::OUT7_OUTPUT));
		addOutput(createOutput<Port24>(out9OutputPosition, module, Switch1616::OUT9_OUTPUT));
		addOutput(createOutput<Port24>(out11OutputPosition, module, Switch1616::OUT11_OUTPUT));
		addOutput(createOutput<Port24>(out13OutputPosition, module, Switch1616::OUT13_OUTPUT));
		addOutput(createOutput<Port24>(out15OutputPosition, module, Switch1616::OUT15_OUTPUT));
		addOutput(createOutput<Port24>(out2OutputPosition, module, Switch1616::OUT2_OUTPUT));
		addOutput(createOutput<Port24>(out4OutputPosition, module, Switch1616::OUT4_OUTPUT));
		addOutput(createOutput<Port24>(out6OutputPosition, module, Switch1616::OUT6_OUTPUT));
		addOutput(createOutput<Port24>(out8OutputPosition, module, Switch1616::OUT8_OUTPUT));
		addOutput(createOutput<Port24>(out10OutputPosition, module, Switch1616::OUT10_OUTPUT));
		addOutput(createOutput<Port24>(out12OutputPosition, module, Switch1616::OUT12_OUTPUT));
		addOutput(createOutput<Port24>(out14OutputPosition, module, Switch1616::OUT14_OUTPUT));
		addOutput(createOutput<Port24>(out16OutputPosition, module, Switch1616::OUT16_OUTPUT));
	}
};

Model* modelSwitch1616 = createModel<Switch1616, Switch1616Widget>("Bogaudio-Switch1616", "SWITCH1616", "16x16 matrix mixer", "Mixer", "Polyphonic");
