#include "Scales.hpp"
Scale indian_penta = {
	.name = "Indian Classical",
	.description = "The Indian Classical scale contains 12 notes, seven of which form the basic notes - Svara - Sa, Ri/Re, Ga, Ma, Pa, Dha, Ni. Unlike the western tradition, the scale uses just intonation and lacks a reference concert pitch, so these notes are similar although not identical in concept to solfege; the pitch of Sa is used as a reference for the other notes in performance. All notes have several acceptable frequency ratios except Sa and Pa (which are always 1:1 and 3:2). The full set of 22 allowed pitches are the Shrutis. The ratios used in SMR co-incide with 'Ptolemy's intense diatonic scale' in increasing octaves of E. Scales 8 to 11 are selections from  Scale 11 is a repeat of Scale 10. SMR describes this scale as pentatonic, which it is not.",
	.scalename = {
		"Svara; E0",
		"Svara; E1",
		"Svara; E2",
		"Svara; E3",
		"Svara; E4",
		"Svara; E5",
		"Svara; E6",
		"Sa, Ri, ma, Dha; 120Hz",
		"Svara over 2 octaves; 120Hz",
		"Svara over 5 octaves; 20Hz",
		"Svara over 5 octaves; 20Hz"},
	.notedesc = {
		"Sa",
		"Ri",
		"Ga",
		"ma",
		"Pa",
		"Dha",
		"Ni",
		"Sa",
		"Ri",
		"Ga",
		"ma",
		"Pa",
		"Dha",
		"Ni",
		"Sa",
		"Ri",
		"Ga",
		"ma",
		"Pa",
		"Dha",
		"Ni",
		"Sa",
		"Ri",
		"Ga",
		"ma",
		"Pa",
		"Dha",
		"Ni",
		"Sa",
		"Ri",
		"Ga",
		"ma",
		"Pa",
		"Dha",
		"Ni",
		"Sa",
		"Ri",
		"Ga",
		"ma",
		"Pa",
		"Dha",
		"Ni",
		"Sa",
		"Ri",
		"Ga",
		"ma",
		"Pa",
		"Dha",
		"Ni",
		"Sa",
		"Ri",
		"Ga",
		"ma",
		"Pa",
		"Dha",
		"Ni",
		"Sa",
		"Ri",
		"Ga",
		"ma",
		"Pa",
		"Dha",
		"Ni",
		"Sa",
		"Ri",
		"Ga",
		"ma",
		"Pa",
		"Dha",
		"Ni",
		"Sa",
		"Ri",
		"Ga",
		"ma",
		"Pa",
		"Dha",
		"Ni",
		"Sa",
		"Ri",
		"Ga",
		"ma",
		"Pa",
		"Dha",
		"Ni",
		"Sa",
		"Ri",
		"Ga",
		"ma",
		"Pa",
		"Dha",
		"Ni",
		"Sa",
		"Ri",
		"Ga",
		"ma",
		"Pa",
		"Dha",
		"Ni",
		"Sa",
		"Ri",
		"Ga",
		"ma",
		"Pa",
		"Dha",
		"Ni",
		"Sa",
		"Ri",
		"Ga",
		"ma",
		"Pa",
		"Dha",
		"Ni",
		"Sa",
		"Ri",
		"Ga",
		"ma",
		"Pa",
		"Dha",
		"Ni",
		"Sa",
		"Ri",
		"Ga",
		"ma",
		"Pa",
		"Dha",
		"Ni",
		"Sa",
		"Ri",
		"Ga",
		"ma",
		"Pa",
		"Dha",
		"Ni",
		"Sa",
		"Ri",
		"Ga",
		"ma",
		"Pa",
		"Dha",
		"Ni",
		"Sa",
		"Ri",
		"Ga",
		"ma",
		"Pa",
		"Dha",
		"Ni",
		"Sa",
		"Ri",
		"ma",
		"Ni",
		"Sa",
		"Ri",
		"ma",
		"Ni",
		"Sa",
		"Ri",
		"ma",
		"Ni",
		"Sa",
		"Ri",
		"ma",
		"Ni",
		"Sa",
		"Ri",
		"ma",
		"Ni",
		"Sa",
		"Sa",
		"Ga",
		"Dha",
		"Ni",
		"Ri^2",
		"ma^2",
		"Pa^2",
		"Sa",
		"Ga",
		"Dha",
		"Ni",
		"Ri^2",
		"ma^2",
		"Pa^2",
		"Sa",
		"Ga",
		"Dha",
		"Ni",
		"Ri^2",
		"ma^2",
		"Pa^2",
		"Sa",
		"Ri",
		"Sa^2",
		"Ga^2",
		"Sa^3",
		"ma^3",
		"Sa^4",
		"Pa^4",
		"Sa^5",
		"Dha^5",
		"Sa^6",
		"Ni^6",
		"Sa",
		"Ri",
		"Sa^2",
		"Ga^2",
		"Sa^3",
		"ma^3",
		"Sa^4",
		"Pa^4",
		"Sa^5",
		"Sa",
		"Ri",
		"Sa^2",
		"Ga^2",
		"Sa^3",
		"ma^3",
		"Sa^4",
		"Pa^4",
		"Sa^5",
		"Dha^5",
		"Sa^6",
		"Ni^6",
		"Sa",
		"Ri",
		"Sa^2",
		"Ga^2",
		"Sa^3",
		"ma^3",
		"Sa^4",
		"Pa^4",
		"Sa^5"},
	.c_maxq48000 = {
		0.002696759144183039,
		0.003033854037205919,
		0.003370948930228799,
		0.003595678858910719,
		0.004045138716274559,
		0.0044945985736384,
		0.005056423395343198,
		0.005393518288366078,
		0.006067708074411838,
		0.006741897860457599,
		0.007191357717821437,
		0.008090277432549118,
		0.008989197147276799,
		0.0101128467906864,
		0.01078703657673216,
		0.01213541614882368,
		0.0134837957209152,
		0.01438271543564287,
		0.01618055486509824,
		0.0179783942945536,
		0.02022569358137279,
		0.005393518288366078,
		0.006067708074411838,
		0.006741897860457599,
		0.007191357717821437,
		0.008090277432549118,
		0.008989197147276799,
		0.0101128467906864,
		0.01078703657673216,
		0.01213541614882368,
		0.0134837957209152,
		0.01438271543564287,
		0.01618055486509824,
		0.0179783942945536,
		0.02022569358137279,
		0.02157407315346431,
		0.02427083229764735,
		0.02696759144183039,
		0.02876543087128575,
		0.03236110973019647,
		0.0359567885891072,
		0.04045138716274559,
		0.01078703657673216,
		0.01213541614882368,
		0.0134837957209152,
		0.01438271543564287,
		0.01618055486509824,
		0.0179783942945536,
		0.02022569358137279,
		0.02157407315346431,
		0.02427083229764735,
		0.02696759144183039,
		0.02876543087128575,
		0.03236110973019647,
		0.0359567885891072,
		0.04045138716274559,
		0.04314814630692863,
		0.04854166459529471,
		0.05393518288366079,
		0.0575308617425715,
		0.06472221946039294,
		0.07191357717821439,
		0.08090277432549117,
		0.02157407315346431,
		0.02427083229764735,
		0.02696759144183039,
		0.02876543087128575,
		0.03236110973019647,
		0.0359567885891072,
		0.04045138716274559,
		0.04314814630692863,
		0.04854166459529471,
		0.05393518288366079,
		0.0575308617425715,
		0.06472221946039294,
		0.07191357717821439,
		0.08090277432549117,
		0.08629629261385725,
		0.09708332919058942,
		0.1078703657673216,
		0.115061723485143,
		0.1294444389207859,
		0.1438271543564288,
		0.1618055486509823,
		0.04314814630692863,
		0.04854166459529471,
		0.05393518288366079,
		0.0575308617425715,
		0.06472221946039294,
		0.07191357717821439,
		0.08090277432549117,
		0.08629629261385725,
		0.09708332919058942,
		0.1078703657673216,
		0.115061723485143,
		0.1294444389207859,
		0.1438271543564288,
		0.1618055486509823,
		0.1725925852277145,
		0.1941666583811788,
		0.2157407315346432,
		0.230123446970286,
		0.2588888778415718,
		0.2876543087128576,
		0.3236110973019647,
		0.08629629261385725,
		0.09708332919058942,
		0.1078703657673216,
		0.115061723485143,
		0.1294444389207859,
		0.1438271543564288,
		0.1618055486509823,
		0.1725925852277145,
		0.1941666583811788,
		0.2157407315346432,
		0.230123446970286,
		0.2588888778415718,
		0.2876543087128576,
		0.3236110973019647,
		0.345185170455429,
		0.3883333167623577,
		0.4314814630692863,
		0.460246893940572,
		0.5177777556831435,
		0.5753086174257152,
		0.6472221946039294,
		0.1725925852277145,
		0.1941666583811788,
		0.2157407315346432,
		0.230123446970286,
		0.2588888778415718,
		0.2876543087128576,
		0.3236110973019647,
		0.345185170455429,
		0.3883333167623577,
		0.4314814630692863,
		0.460246893940572,
		0.5177777556831435,
		0.5753086174257152,
		0.6472221946039294,
		0.690370340910858,
		0.7766666335247153,
		0.8629629261385726,
		0.920493787881144,
		1.035555511366287,
		1.15061723485143,
		1.294444389207859,
		0.01570796326794896,
		0.01767145867644259,
		0.02094395102393195,
		0.02945243112740431,
		0.03141592653589793,
		0.03534291735288517,
		0.0418879020478639,
		0.05890486225480862,
		0.06283185307179585,
		0.07068583470577035,
		0.08377580409572781,
		0.1178097245096172,
		0.1256637061435917,
		0.1413716694115407,
		0.1675516081914556,
		0.2356194490192345,
		0.2513274122871834,
		0.2827433388230814,
		0.3351032163829112,
		0.471238898038469,
		0.5026548245743668,
		0.01570796326794896,
		0.01963495408493621,
		0.02617993877991494,
		0.02945243112740431,
		0.03534291735288517,
		0.0418879020478639,
		0.0471238898038469,
		0.06283185307179585,
		0.07853981633974483,
		0.1047197551196598,
		0.1178097245096172,
		0.1413716694115407,
		0.1675516081914556,
		0.1884955592153876,
		0.2513274122871834,
		0.3141592653589793,
		0.4188790204786391,
		0.471238898038469,
		0.5654866776461628,
		0.6702064327658225,
		0.7539822368615504,
		0.002617993877991494,
		0.002945243112740431,
		0.005235987755982988,
		0.006544984694978736,
		0.01047197551196598,
		0.01396263401595463,
		0.02094395102393195,
		0.03141592653589793,
		0.0418879020478639,
		0.1256637061435917,
		0.08377580409572781,
		0.1570796326794897,
		0.1675516081914556,
		0.1884955592153876,
		0.3351032163829112,
		0.4188790204786391,
		0.6702064327658225,
		0.8936085770210966,
		1.340412865531645,
		2.010619298297467,
		2.010619298297467,
		0.002617993877991494,
		0.002945243112740431,
		0.005235987755982988,
		0.006544984694978736,
		0.01047197551196598,
		0.01396263401595463,
		0.02094395102393195,
		0.03141592653589793,
		0.0418879020478639,
		0.1256637061435917,
		0.08377580409572781,
		0.1570796326794897,
		0.1675516081914556,
		0.1884955592153876,
		0.3351032163829112,
		0.4188790204786391,
		0.6702064327658225,
		0.8936085770210966,
		1.340412865531645,
		2.010619298297467,
		2.010619298297467
	},
	.c_maxq96000 = {
		0.00134837957209152,
		0.00151692701860296,
		0.0016854744651144,
		0.001797839429455359,
		0.002022569358137279,
		0.0022472992868192,
		0.002528211697671599,
		0.002696759144183039,
		0.003033854037205919,
		0.003370948930228799,
		0.003595678858910719,
		0.004045138716274559,
		0.0044945985736384,
		0.005056423395343198,
		0.005393518288366078,
		0.006067708074411838,
		0.006741897860457599,
		0.007191357717821437,
		0.008090277432549118,
		0.008989197147276799,
		0.0101128467906864,
		0.002696759144183039,
		0.003033854037205919,
		0.003370948930228799,
		0.003595678858910719,
		0.004045138716274559,
		0.0044945985736384,
		0.005056423395343198,
		0.005393518288366078,
		0.006067708074411838,
		0.006741897860457599,
		0.007191357717821437,
		0.008090277432549118,
		0.008989197147276799,
		0.0101128467906864,
		0.01078703657673216,
		0.01213541614882368,
		0.0134837957209152,
		0.01438271543564287,
		0.01618055486509824,
		0.0179783942945536,
		0.02022569358137279,
		0.005393518288366078,
		0.006067708074411838,
		0.006741897860457599,
		0.007191357717821437,
		0.008090277432549118,
		0.008989197147276799,
		0.0101128467906864,
		0.01078703657673216,
		0.01213541614882368,
		0.0134837957209152,
		0.01438271543564287,
		0.01618055486509824,
		0.0179783942945536,
		0.02022569358137279,
		0.02157407315346431,
		0.02427083229764735,
		0.02696759144183039,
		0.02876543087128575,
		0.03236110973019647,
		0.0359567885891072,
		0.04045138716274559,
		0.01078703657673216,
		0.01213541614882368,
		0.0134837957209152,
		0.01438271543564287,
		0.01618055486509824,
		0.0179783942945536,
		0.02022569358137279,
		0.02157407315346431,
		0.02427083229764735,
		0.02696759144183039,
		0.02876543087128575,
		0.03236110973019647,
		0.0359567885891072,
		0.04045138716274559,
		0.04314814630692863,
		0.04854166459529471,
		0.05393518288366079,
		0.0575308617425715,
		0.06472221946039294,
		0.07191357717821439,
		0.08090277432549117,
		0.02157407315346431,
		0.02427083229764735,
		0.02696759144183039,
		0.02876543087128575,
		0.03236110973019647,
		0.0359567885891072,
		0.04045138716274559,
		0.04314814630692863,
		0.04854166459529471,
		0.05393518288366079,
		0.0575308617425715,
		0.06472221946039294,
		0.07191357717821439,
		0.08090277432549117,
		0.08629629261385725,
		0.09708332919058942,
		0.1078703657673216,
		0.115061723485143,
		0.1294444389207859,
		0.1438271543564288,
		0.1618055486509823,
		0.04314814630692863,
		0.04854166459529471,
		0.05393518288366079,
		0.0575308617425715,
		0.06472221946039294,
		0.07191357717821439,
		0.08090277432549117,
		0.08629629261385725,
		0.09708332919058942,
		0.1078703657673216,
		0.115061723485143,
		0.1294444389207859,
		0.1438271543564288,
		0.1618055486509823,
		0.1725925852277145,
		0.1941666583811788,
		0.2157407315346432,
		0.230123446970286,
		0.2588888778415718,
		0.2876543087128576,
		0.3236110973019647,
		0.08629629261385725,
		0.09708332919058942,
		0.1078703657673216,
		0.115061723485143,
		0.1294444389207859,
		0.1438271543564288,
		0.1618055486509823,
		0.1725925852277145,
		0.1941666583811788,
		0.2157407315346432,
		0.230123446970286,
		0.2588888778415718,
		0.2876543087128576,
		0.3236110973019647,
		0.345185170455429,
		0.3883333167623577,
		0.4314814630692863,
		0.460246893940572,
		0.5177777556831435,
		0.5753086174257152,
		0.6472221946039294,
		0.007853981633974482,
		0.008835729338221293,
		0.01047197551196598,
		0.01472621556370216,
		0.01570796326794896,
		0.01767145867644259,
		0.02094395102393195,
		0.02945243112740431,
		0.03141592653589793,
		0.03534291735288517,
		0.0418879020478639,
		0.05890486225480862,
		0.06283185307179585,
		0.07068583470577035,
		0.08377580409572781,
		0.1178097245096172,
		0.1256637061435917,
		0.1413716694115407,
		0.1675516081914556,
		0.2356194490192345,
		0.2513274122871834,
		0.007853981633974482,
		0.009817477042468103,
		0.01308996938995747,
		0.01472621556370216,
		0.01767145867644259,
		0.02094395102393195,
		0.02356194490192345,
		0.03141592653589793,
		0.03926990816987241,
		0.05235987755982989,
		0.05890486225480862,
		0.07068583470577035,
		0.08377580409572781,
		0.0942477796076938,
		0.1256637061435917,
		0.1570796326794897,
		0.2094395102393196,
		0.2356194490192345,
		0.2827433388230814,
		0.3351032163829112,
		0.3769911184307752,
		0.001308996938995747,
		0.001472621556370216,
		0.002617993877991494,
		0.003272492347489368,
		0.005235987755982988,
		0.006981317007977317,
		0.01047197551196598,
		0.01570796326794896,
		0.02094395102393195,
		0.06283185307179585,
		0.0418879020478639,
		0.07853981633974483,
		0.08377580409572781,
		0.0942477796076938,
		0.1675516081914556,
		0.2094395102393196,
		0.3351032163829112,
		0.4468042885105483,
		0.6702064327658225,
		1.005309649148734,
		1.005309649148734,
		0.001308996938995747,
		0.001472621556370216,
		0.002617993877991494,
		0.003272492347489368,
		0.005235987755982988,
		0.006981317007977317,
		0.01047197551196598,
		0.01570796326794896,
		0.02094395102393195,
		0.06283185307179585,
		0.0418879020478639,
		0.07853981633974483,
		0.08377580409572781,
		0.0942477796076938,
		0.1675516081914556,
		0.2094395102393196,
		0.3351032163829112,
		0.4468042885105483,
		0.6702064327658225,
		1.005309649148734,
		1.005309649148734
	},
	.c_bpre4800022 = {
		{ 0.001347469458600309, 0.9986525305414123, -1.998645262951418 },
		{ 0.001515774609280675, 0.9984842253907511, -1.998475028133127 },
		{ 0.001684057929072506, 0.9983159420709722, -1.998304588311715 },
		{ 0.001796226696311171, 0.9982037733037148, -1.998190855988075 },
		{ 0.002020526423050801, 0.9979794735769538, -1.997963126965603 },
		{ 0.002244775748908134, 0.9977552242510922, -1.997735045547074 },
		{ 0.002525016547236225, 0.9974749834527756, -1.997449448407484 },
		{ 0.002693123243258867, 0.9973068767567663, -1.997277826022114 },
		{ 0.003029258170996501, 0.9969707418290105, -1.996933980585402 },
		{ 0.003365273283988751, 0.9966347267160116, -1.9965893501925 },
		{ 0.003589220440739121, 0.9964107795592673, -1.99635915701447 },
		{ 0.004036970319075042, 0.9959630296809343, -1.99589770949346 },
		{ 0.004484512479653148, 0.995515487520347, -1.995434863602991 },
		{ 0.005043663897870782, 0.994956336102141, -1.994854325099077 },
		{ 0.005379000083444052, 0.9946209999165567, -1.994504953804058 },
		{ 0.006049339936927031, 0.993950660063087, -1.993803838820802 },
		{ 0.006719247508495239, 0.9932807524922695, -1.993099551946427 },
		{ 0.007165571374369114, 0.9928344286257348, -1.992628310265593 },
		{ 0.008057617540253813, 0.991942382460216, -1.991681633985807 },
		{ 0.008948927080083109, 0.991051072920046, -1.990729304308754 },
		{ 0.0100618892502266, 0.9899381107497967, -1.989531103560697 },
		{ 0.002693123243258867, 0.9973068767567663, -1.997277826022114 },
		{ 0.003029258170996501, 0.9969707418290105, -1.996933980585402 },
		{ 0.003365273283988751, 0.9966347267160116, -1.9965893501925 },
		{ 0.003589220440739121, 0.9964107795592673, -1.99635915701447 },
		{ 0.004036970319075042, 0.9959630296809343, -1.99589770949346 },
		{ 0.004484512479653148, 0.995515487520347, -1.995434863602991 },
		{ 0.005043663897870782, 0.994956336102141, -1.994854325099077 },
		{ 0.005379000083444052, 0.9946209999165567, -1.994504953804058 },
		{ 0.006049339936927031, 0.993950660063087, -1.993803838820802 },
		{ 0.006719247508495239, 0.9932807524922695, -1.993099551946427 },
		{ 0.007165571374369114, 0.9928344286257348, -1.992628310265593 },
		{ 0.008057617540253813, 0.991942382460216, -1.991681633985807 },
		{ 0.008948927080083109, 0.991051072920046, -1.990729304308754 },
		{ 0.0100618892502266, 0.9899381107497967, -1.989531103560697 },
		{ 0.01072907947467007, 0.9892709205254852, -1.988807993479254 },
		{ 0.01206211122500698, 0.9879378887756927, -1.987352393798842 },
		{ 0.01339328215526003, 0.9866067178448656, -1.985884382338201 },
		{ 0.0142797973356175, 0.9857202026645889, -1.984898714999682 },
		{ 0.01605037427873726, 0.9839496257214949, -1.982910876471123 },
		{ 0.01781777086428339, 0.9821822291359744, -1.980900991311439 },
		{ 0.02002253688516958, 0.9799774631148763, -1.978357749125685 },
		{ 0.005379000083444052, 0.9946209999165567, -1.994504953804058 },
		{ 0.006049339936927031, 0.993950660063087, -1.993803838820802 },
		{ 0.006719247508495239, 0.9932807524922695, -1.993099551946427 },
		{ 0.007165571374369114, 0.9928344286257348, -1.992628310265593 },
		{ 0.008057617540253813, 0.991942382460216, -1.991681633985807 },
		{ 0.008948927080083109, 0.991051072920046, -1.990729304308754 },
		{ 0.0100618892502266, 0.9899381107497967, -1.989531103560697 },
		{ 0.01072907947467007, 0.9892709205254852, -1.988807993479254 },
		{ 0.01206211122500698, 0.9879378887756927, -1.987352393798842 },
		{ 0.01339328215526003, 0.9866067178448656, -1.985884382338201 },
		{ 0.0142797973356175, 0.9857202026645889, -1.984898714999682 },
		{ 0.01605037427873726, 0.9839496257214949, -1.982910876471123 },
		{ 0.01781777086428339, 0.9821822291359744, -1.980900991311439 },
		{ 0.02002253688516958, 0.9799774631148763, -1.978357749125685 },
		{ 0.02134304580296814, 0.9786569541973403, -1.976815340305844 },
		{ 0.02397866404098227, 0.9760213359590177, -1.973693750252121 },
		{ 0.02660718430363138, 0.9733928156966185, -1.970523213902598 },
		{ 0.02835561846510462, 0.9716443815350921, -1.968382413125614 },
		{ 0.03184307067692594, 0.9681569293231912, -1.964036102789322 },
		{ 0.03531800563126537, 0.9646819943687984, -1.959603950278459 },
		{ 0.03964417178702166, 0.9603558282130693, -1.953943801650932 },
		{ 0.01072907947467007, 0.9892709205254852, -1.988807993479254 },
		{ 0.01206211122500698, 0.9879378887756927, -1.987352393798842 },
		{ 0.01339328215526003, 0.9866067178448656, -1.985884382338201 },
		{ 0.0142797973356175, 0.9857202026645889, -1.984898714999682 },
		{ 0.01605037427873726, 0.9839496257214949, -1.982910876471123 },
		{ 0.01781777086428339, 0.9821822291359744, -1.980900991311439 },
		{ 0.02002253688516958, 0.9799774631148763, -1.978357749125685 },
		{ 0.02134304580296814, 0.9786569541973403, -1.976815340305844 },
		{ 0.02397866404098227, 0.9760213359590177, -1.973693750252121 },
		{ 0.02660718430363138, 0.9733928156966185, -1.970523213902598 },
		{ 0.02835561846510462, 0.9716443815350921, -1.968382413125614 },
		{ 0.03184307067692594, 0.9681569293231912, -1.964036102789322 },
		{ 0.03531800563126537, 0.9646819943687984, -1.959603950278459 },
		{ 0.03964417178702166, 0.9603558282130693, -1.953943801650932 },
		{ 0.04223050331532988, 0.9577694966846801, -1.950484218257796 },
		{ 0.04738235175277397, 0.9526176482472259, -1.943422994117022 },
		{ 0.05250648836352298, 0.9474935116364839, -1.936173958630653 },
		{ 0.05590725762203508, 0.9440927423779841, -1.931237812357833 },
		{ 0.06267222155150699, 0.9373277784485485, -1.921119619245367 },
		{ 0.06938877155837442, 0.9306112284426293, -1.910677020516647 },
		{ 0.07771644176849074, 0.9222835582360495, -1.897174859521674 },
		{ 0.02134304580296814, 0.9786569541973403, -1.976815340305844 },
		{ 0.02397866404098227, 0.9760213359590177, -1.973693750252121 },
		{ 0.02660718430363138, 0.9733928156966185, -1.970523213902598 },
		{ 0.02835561846510462, 0.9716443815350921, -1.968382413125614 },
		{ 0.03184307067692594, 0.9681569293231912, -1.964036102789322 },
		{ 0.03531800563126537, 0.9646819943687984, -1.959603950278459 },
		{ 0.03964417178702166, 0.9603558282130693, -1.953943801650932 },
		{ 0.04223050331532988, 0.9577694966846801, -1.950484218257796 },
		{ 0.04738235175277397, 0.9526176482472259, -1.943422994117022 },
		{ 0.05250648836352298, 0.9474935116364839, -1.936173958630653 },
		{ 0.05590725762203508, 0.9440927423779841, -1.931237812357833 },
		{ 0.06267222155150699, 0.9373277784485485, -1.921119619245367 },
		{ 0.06938877155837442, 0.9306112284426293, -1.910677020516647 },
		{ 0.07771644176849074, 0.9222835582360495, -1.897174859521674 },
		{ 0.08267759122039448, 0.9173224087796253, -1.88883644405978 },
		{ 0.09251937867549292, 0.9074806213299151, -1.871636969452478 },
		{ 0.1022561629226461, 0.8977438370788348, -1.853750398190039 },
		{ 0.1086886604482148, 0.8913113395555151, -1.841453257745977 },
		{ 0.1214168657666687, 0.8785831342387348, -1.815979113313675 },
		{ 0.1339627414984425, 0.8660372585035001, -1.789365304282473 },
		{ 0.1493935949303927, 0.8506064050717757, -1.75454727961115 },
		{ 0.04223050331532988, 0.9577694966846801, -1.950484218257796 },
		{ 0.04738235175277397, 0.9526176482472259, -1.943422994117022 },
		{ 0.05250648836352298, 0.9474935116364839, -1.936173958630653 },
		{ 0.05590725762203508, 0.9440927423779841, -1.931237812357833 },
		{ 0.06267222155150699, 0.9373277784485485, -1.921119619245367 },
		{ 0.06938877155837442, 0.9306112284426293, -1.910677020516647 },
		{ 0.07771644176849074, 0.9222835582360495, -1.897174859521674 },
		{ 0.08267759122039448, 0.9173224087796253, -1.88883644405978 },
		{ 0.09251937867549292, 0.9074806213299151, -1.871636969452478 },
		{ 0.1022561629226461, 0.8977438370788348, -1.853750398190039 },
		{ 0.1086886604482148, 0.8913113395555151, -1.841453257745977 },
		{ 0.1214168657666687, 0.8785831342387348, -1.815979113313675 },
		{ 0.1339627414984425, 0.8660372585035001, -1.789365304282473 },
		{ 0.1493935949303927, 0.8506064050717757, -1.75454727961115 },
		{ 0.1585195983507839, 0.8414804016492542, -1.732856688975128 },
		{ 0.1764794609044175, 0.8235205390962201, -1.68774362522255 },
		{ 0.1940560029897971, 0.8059439970130292, -1.640423687596002 },
		{ 0.2055646159376632, 0.7944353840633339, -1.607711289509566 },
		{ 0.2280911710183143, 0.7719088289817406, -1.539649268784859 },
		{ 0.2499789759980485, 0.7500210240037097, -1.468310894512691 },
		{ 0.276468270101651, 0.7235317298993846, -1.374968257513736 },
		{ 0.08267759122039448, 0.9173224087796253, -1.88883644405978 },
		{ 0.09251937867549292, 0.9074806213299151, -1.871636969452478 },
		{ 0.1022561629226461, 0.8977438370788348, -1.853750398190039 },
		{ 0.1086886604482148, 0.8913113395555151, -1.841453257745977 },
		{ 0.1214168657666687, 0.8785831342387348, -1.815979113313675 },
		{ 0.1339627414984425, 0.8660372585035001, -1.789365304282473 },
		{ 0.1493935949303927, 0.8506064050717757, -1.75454727961115 },
		{ 0.1585195983507839, 0.8414804016492542, -1.732856688975128 },
		{ 0.1764794609044175, 0.8235205390962201, -1.68774362522255 },
		{ 0.1940560029897971, 0.8059439970130292, -1.640423687596002 },
		{ 0.2055646159376632, 0.7944353840633339, -1.607711289509566 },
		{ 0.2280911710183143, 0.7719088289817406, -1.539649268784859 },
		{ 0.2499789759980485, 0.7500210240037097, -1.468310894512691 },
		{ 0.276468270101651, 0.7235317298993846, -1.374968257513736 },
		{ 0.2919107336402809, 0.7080892663597902, -1.316954421651064 },
		{ 0.3218139216878552, 0.6781860783133293, -1.196972106492821 },
		{ 0.3504538485519256, 0.6495461514481606, -1.072517239991206 },
		{ 0.3688720074772516, 0.6311279925240266, -0.9875300660491951 },
		{ 0.4041567597401386, 0.5958432402599622, -0.8139572028442086 },
		{ 0.437468831728493, 0.5625311682716643, -0.6373935838970861 },
		{ 0.4765021784578911, 0.5234978215425609, -0.4156824389267194 },
		{ 0.007823219707438548, 0.9921767802925616, -1.991931010387075 },
		{ 0.008796808995975706, 0.9912031910040245, -1.990892292178777 },
		{ 0.01041733527314638, 0.9895826647268539, -1.989146316370315 },
		{ 0.01461831515552326, 0.9853816848444767, -1.984520641687532 },
		{ 0.01558523664828609, 0.9844147633517137, -1.983435574456665 },
		{ 0.01751623414343931, 0.9824837658565605, -1.98124571288586 },
		{ 0.02072614967209857, 0.9792738503279012, -1.977537690880311 },
		{ 0.02902293517306048, 0.9709770648269396, -1.967558622279595 },
		{ 0.03092757369518973, 0.9690724263048105, -1.965186911663389 },
		{ 0.03472564982831124, 0.9652743501716891, -1.96036666002138 },
		{ 0.04102272606396738, 0.9589772739360324, -1.952106864909625 },
		{ 0.05720353958006127, 0.9427964604199386, -1.929329883127006 },
		{ 0.06089863257570743, 0.9391013674242924, -1.923810973960849 },
		{ 0.06824542890062368, 0.9317545710993764, -1.912482726290573 },
		{ 0.0803625880742162, 0.9196374119257839, -1.892754880771601 },
		{ 0.1111348342196352, 0.8888651657803648, -1.836675670890762 },
		{ 0.1180886217018235, 0.8819113782981763, -1.822787671753789 },
		{ 0.1318334192354171, 0.8681665807645829, -1.793988571300012 },
		{ 0.1542670305864461, 0.8457329694135539, -1.743066602086797 },
		{ 0.2099187170622442, 0.7900812829377557, -1.594974101926606 },
		{ 0.2222323208282106, 0.7777676791717891, -1.55786969282571 },
		{ 0.007823219707438548, 0.9921767802925616, -1.991931010387075 },
		{ 0.009769442934496907, 0.9902305570655034, -1.989846921182752 },
		{ 0.0130046683423247, 0.9869953316576753, -1.986314437983862 },
		{ 0.01461831515552326, 0.9853816848444767, -1.984520641687532 },
		{ 0.01751623414343931, 0.9824837658565605, -1.98124571288586 },
		{ 0.02072614967209857, 0.9792738503279012, -1.977537690880311 },
		{ 0.02328652962523278, 0.9767134703747672, -1.974519071258224 },
		{ 0.03092757369518973, 0.9690724263048105, -1.965186911663389 },
		{ 0.03850884019859235, 0.9614911598014076, -1.955444537170417 },
		{ 0.05101271384588681, 0.9489872861541132, -1.938310529875129 },
		{ 0.05720353958006127, 0.9427964604199386, -1.929329883127006 },
		{ 0.06824542890062368, 0.9317545710993764, -1.912482726290573 },
		{ 0.0803625880742162, 0.9196374119257839, -1.892754880771601 },
		{ 0.08994275932397493, 0.9100572406760247, -1.876224875678287 },
		{ 0.1180886217018235, 0.8819113782981763, -1.822787671753789 },
		{ 0.145364000846767, 0.8546359991532334, -1.763863652352052 },
		{ 0.188961302513964, 0.8110386974860359, -1.654466175697709 },
		{ 0.2099187170622442, 0.7900812829377557, -1.594974101926606 },
		{ 0.2462867880435328, 0.7537132119564671, -1.480709038180846 },
		{ 0.2847357444469325, 0.7152642555530675, -1.344241374651668 },
		{ 0.3140778340658338, 0.6859221659341663, -1.228984367256976 },
		{ 0.001308140576202039, 0.9986918594237979, -1.998685010018692 },
		{ 0.001471537781308484, 0.9985284622186918, -1.99851979415036 },
		{ 0.002614569920637108, 0.997385430079363, -1.997358050414093 },
		{ 0.003267143580597968, 0.9967328564194023, -1.996690089724441 },
		{ 0.005222303865404294, 0.9947776961345957, -1.994668321207849 },
		{ 0.006957025891089095, 0.9930429741094544, -1.992848699056857 },
		{ 0.01041733527314638, 0.9895826647268539, -1.989146316370315 },
		{ 0.01558523664828609, 0.9844147633517137, -1.983435574456665 },
		{ 0.02072614967209857, 0.9792738503279012, -1.977537690880311 },
		{ 0.06089863257570743, 0.9391013674242924, -1.923810973960849 },
		{ 0.04102272606396738, 0.9589772739360324, -1.952106864909625 },
		{ 0.07553474962374385, 0.9244652503762558, -1.900771889676646 },
		{ 0.0803625880742162, 0.9196374119257839, -1.892754880771601 },
		{ 0.08994275932397493, 0.9100572406760247, -1.876224875678287 },
		{ 0.1542670305864461, 0.8457329694135539, -1.743066602086797 },
		{ 0.188961302513964, 0.8110386974860359, -1.654466175697709 },
		{ 0.2847357444469325, 0.7152642555530675, -1.344241374651668 },
		{ 0.3603310529401623, 0.6396689470605481, -1.027422254012692 },
		{ 0.4883970447281162, 0.5116029552718837, -0.3451758500940907 },
		{ 0.6340686930587067, 0.3659313069412933, 0.581585264222375 },
		{ 0.6340686930587067, 0.3659313069412933, 0.581585264222375 },
		{ 0.001308140576202039, 0.9986918594237979, -1.998685010018692 },
		{ 0.001471537781308484, 0.9985284622186918, -1.99851979415036 },
		{ 0.002614569920637108, 0.997385430079363, -1.997358050414093 },
		{ 0.003267143580597968, 0.9967328564194023, -1.996690089724441 },
		{ 0.005222303865404294, 0.9947776961345957, -1.994668321207849 },
		{ 0.006957025891089095, 0.9930429741094544, -1.992848699056857 },
		{ 0.01041733527314638, 0.9895826647268539, -1.989146316370315 },
		{ 0.01558523664828609, 0.9844147633517137, -1.983435574456665 },
		{ 0.02072614967209857, 0.9792738503279012, -1.977537690880311 },
		{ 0.06089863257570743, 0.9391013674242924, -1.923810973960849 },
		{ 0.04102272606396738, 0.9589772739360324, -1.952106864909625 },
		{ 0.07553474962374385, 0.9244652503762558, -1.900771889676646 },
		{ 0.0803625880742162, 0.9196374119257839, -1.892754880771601 },
		{ 0.08994275932397493, 0.9100572406760247, -1.876224875678287 },
		{ 0.1542670305864461, 0.8457329694135539, -1.743066602086797 },
		{ 0.188961302513964, 0.8110386974860359, -1.654466175697709 },
		{ 0.2847357444469325, 0.7152642555530675, -1.344241374651668 },
		{ 0.3603310529401623, 0.6396689470605481, -1.027422254012692 },
		{ 0.4883970447281162, 0.5116029552718837, -0.3451758500940907 },
		{ 0.6340686930587067, 0.3659313069412933, 0.581585264222375 },
		{ 0.6340686930587067, 0.3659313069412933, 0.581585264222375 }
	},
	.c_bpre9600022 = {
		{ 0.0006739618415823943, 0.9993260381584242, -1.99932422064784 },
		{ 0.0007581747190925375, 0.9992418252809234, -1.999239525093553 },
		{ 0.0008423837697442345, 0.9991576162302783, -1.99915477659292 },
		{ 0.0008985170145679666, 0.9991014829854448, -1.999098252203122 },
		{ 0.001010774043608552, 0.9989892259563935, -1.998985137234034 },
		{ 0.001123018459684778, 0.9988769815403157, -1.998871934025308 },
		{ 0.001263306244951859, 0.9987366937550536, -1.998730305951204 },
		{ 0.001347469458600309, 0.9986525305414123, -1.998645262951418 },
		{ 0.001515777876783609, 0.9984842221232194, -1.998475024825927 },
		{ 0.001684054662046742, 0.9983159453379533, -1.998304591622767 },
		{ 0.001796223429674471, 0.9982037765703288, -1.998190859301694 },
		{ 0.002020526423050801, 0.9979794735769538, -1.997963126965603 },
		{ 0.002244775748908134, 0.9977552242510922, -1.997735045547074 },
		{ 0.002525019811459385, 0.9974749801885464, -1.997449445077191 },
		{ 0.00269312650691332, 0.9973068734930874, -1.997277822687978 },
		{ 0.003029258170996501, 0.9969707418290105, -1.996933980585402 },
		{ 0.003365286330289501, 0.9966347136700934, -1.99658933679447 },
		{ 0.003589226962277654, 0.996410773037774, -1.996359150305214 },
		{ 0.004036957282176235, 0.9959630427180598, -1.995897722952903 },
		{ 0.004484518995351341, 0.9955154810047133, -1.995434856852812 },
		{ 0.005043663897870782, 0.994956336102141, -1.994854325099077 },
		{ 0.001347469458600309, 0.9986525305414123, -1.998645262951418 },
		{ 0.001515777876783609, 0.9984842221232194, -1.998475024825927 },
		{ 0.001684054662046742, 0.9983159453379533, -1.998304591622767 },
		{ 0.001796223429674471, 0.9982037765703288, -1.998190859301694 },
		{ 0.002020526423050801, 0.9979794735769538, -1.997963126965603 },
		{ 0.002244775748908134, 0.9977552242510922, -1.997735045547074 },
		{ 0.002525019811459385, 0.9974749801885464, -1.997449445077191 },
		{ 0.00269312650691332, 0.9973068734930874, -1.997277822687978 },
		{ 0.003029258170996501, 0.9969707418290105, -1.996933980585402 },
		{ 0.003365286330289501, 0.9966347136700934, -1.99658933679447 },
		{ 0.003589226962277654, 0.996410773037774, -1.996359150305214 },
		{ 0.004036957282176235, 0.9959630427180598, -1.995897722952903 },
		{ 0.004484518995351341, 0.9955154810047133, -1.995434856852812 },
		{ 0.005043663897870782, 0.994956336102141, -1.994854325099077 },
		{ 0.005379006593300218, 0.9946209934067776, -1.994504947013024 },
		{ 0.006049352948047721, 0.9939506470523033, -1.9938038251775 },
		{ 0.006719215002756559, 0.9932807849973068, -1.993099586207553 },
		{ 0.007165571374369114, 0.9928344286257348, -1.992628310265593 },
		{ 0.008057650001138001, 0.9919423499989781, -1.991681599419421 },
		{ 0.008948927080083109, 0.991051072920046, -1.990729304308754 },
		{ 0.0100618892502266, 0.9899381107497967, -1.989531103560697 },
		{ 0.00269312650691332, 0.9973068734930874, -1.997277822687978 },
		{ 0.003029258170996501, 0.9969707418290105, -1.996933980585402 },
		{ 0.003365286330289501, 0.9966347136700934, -1.99658933679447 },
		{ 0.003589226962277654, 0.996410773037774, -1.996359150305214 },
		{ 0.004036957282176235, 0.9959630427180598, -1.995897722952903 },
		{ 0.004484518995351341, 0.9955154810047133, -1.995434856852812 },
		{ 0.005043663897870782, 0.994956336102141, -1.994854325099077 },
		{ 0.005379006593300218, 0.9946209934067776, -1.994504947013024 },
		{ 0.006049352948047721, 0.9939506470523033, -1.9938038251775 },
		{ 0.006719215002756559, 0.9932807849973068, -1.993099586207553 },
		{ 0.007165571374369114, 0.9928344286257348, -1.992628310265593 },
		{ 0.008057650001138001, 0.9919423499989781, -1.991681599419421 },
		{ 0.008948927080083109, 0.991051072920046, -1.990729304308754 },
		{ 0.0100618892502266, 0.9899381107497967, -1.989531103560697 },
		{ 0.01072907947467007, 0.9892709205254852, -1.988807993479254 },
		{ 0.01206207889411533, 0.987937921105885, -1.987352429277083 },
		{ 0.01339328215526003, 0.9866067178448656, -1.985884382338201 },
		{ 0.01427976507789158, 0.9857202349222076, -1.984898750981986 },
		{ 0.01605034207888764, 0.9839496579211717, -1.982910912855292 },
		{ 0.01781773872221937, 0.9821822612778132, -1.980901028096285 },
		{ 0.02002253688516958, 0.9799774631148763, -1.978357749125685 },
		{ 0.005379006593300218, 0.9946209934067776, -1.994504947013024 },
		{ 0.006049352948047721, 0.9939506470523033, -1.9938038251775 },
		{ 0.006719215002756559, 0.9932807849973068, -1.993099586207553 },
		{ 0.007165571374369114, 0.9928344286257348, -1.992628310265593 },
		{ 0.008057650001138001, 0.9919423499989781, -1.991681599419421 },
		{ 0.008948927080083109, 0.991051072920046, -1.990729304308754 },
		{ 0.0100618892502266, 0.9899381107497967, -1.989531103560697 },
		{ 0.01072907947467007, 0.9892709205254852, -1.988807993479254 },
		{ 0.01206207889411533, 0.987937921105885, -1.987352429277083 },
		{ 0.01339328215526003, 0.9866067178448656, -1.985884382338201 },
		{ 0.01427976507789158, 0.9857202349222076, -1.984898750981986 },
		{ 0.01605034207888764, 0.9839496579211717, -1.982910912855292 },
		{ 0.01781773872221937, 0.9821822612778132, -1.980901028096285 },
		{ 0.02002253688516958, 0.9799774631148763, -1.978357749125685 },
		{ 0.02134301377619035, 0.9786569862238147, -1.976815377888588 },
		{ 0.02397866404098227, 0.9760213359590177, -1.973693750252121 },
		{ 0.02660721615759011, 0.9733927838424136, -1.970523175131998 },
		{ 0.02835565026190513, 0.9716443497381047, -1.968382373961191 },
		{ 0.03184310235969745, 0.9681568976403303, -1.964036062841464 },
		{ 0.03531806876999911, 0.9646819312305116, -1.959603868824781 },
		{ 0.03964404607895317, 0.9603559539233613, -1.953943968425716 },
		{ 0.01072907947467007, 0.9892709205254852, -1.988807993479254 },
		{ 0.01206207889411533, 0.987937921105885, -1.987352429277083 },
		{ 0.01339328215526003, 0.9866067178448656, -1.985884382338201 },
		{ 0.01427976507789158, 0.9857202349222076, -1.984898750981986 },
		{ 0.01605034207888764, 0.9839496579211717, -1.982910912855292 },
		{ 0.01781773872221937, 0.9821822612778132, -1.980901028096285 },
		{ 0.02002253688516958, 0.9799774631148763, -1.978357749125685 },
		{ 0.02134301377619035, 0.9786569862238147, -1.976815377888588 },
		{ 0.02397866404098227, 0.9760213359590177, -1.973693750252121 },
		{ 0.02660721615759011, 0.9733927838424136, -1.970523175131998 },
		{ 0.02835565026190513, 0.9716443497381047, -1.968382373961191 },
		{ 0.03184310235969745, 0.9681568976403303, -1.964036062841464 },
		{ 0.03531806876999911, 0.9646819312305116, -1.959603868824781 },
		{ 0.03964404607895317, 0.9603559539233613, -1.953943968425716 },
		{ 0.04223050331532988, 0.9577694966846801, -1.950484218257796 },
		{ 0.04738222705817383, 0.9526177729445925, -1.943423167777977 },
		{ 0.05250655037757846, 0.9474934496231806, -1.936173869532924 },
		{ 0.05590713404247251, 0.9440928659594431, -1.931237993554001 },
		{ 0.06267234425014567, 0.9373276557526374, -1.921119432106049 },
		{ 0.06938877155837442, 0.9306112284426293, -1.910677020516647 },
		{ 0.07771674358161415, 0.92228325641951, -1.897174358961363 },
		{ 0.02134301377619035, 0.9786569862238147, -1.976815377888588 },
		{ 0.02397866404098227, 0.9760213359590177, -1.973693750252121 },
		{ 0.02660721615759011, 0.9733927838424136, -1.970523175131998 },
		{ 0.02835565026190513, 0.9716443497381047, -1.968382373961191 },
		{ 0.03184310235969745, 0.9681568976403303, -1.964036062841464 },
		{ 0.03531806876999911, 0.9646819312305116, -1.959603868824781 },
		{ 0.03964404607895317, 0.9603559539233613, -1.953943968425716 },
		{ 0.04223050331532988, 0.9577694966846801, -1.950484218257796 },
		{ 0.04738222705817383, 0.9526177729445925, -1.943423167777977 },
		{ 0.05250655037757846, 0.9474934496231806, -1.936173869532924 },
		{ 0.05590713404247251, 0.9440928659594431, -1.931237993554001 },
		{ 0.06267234425014567, 0.9373276557526374, -1.921119432106049 },
		{ 0.06938877155837442, 0.9306112284426293, -1.910677020516647 },
		{ 0.07771674358161415, 0.92228325641951, -1.897174358961363 },
		{ 0.08267759122039448, 0.9173224087796253, -1.88883644405978 },
		{ 0.0925196756427077, 0.907480324357625, -1.871636437174008 },
		{ 0.1022561629226461, 0.8977438370788348, -1.853750398190039 },
		{ 0.1086889521259145, 0.891311047874609, -1.841452691402135 },
		{ 0.1214165782455891, 0.8785834217544403, -1.815979706018884 },
		{ 0.1339624580873561, 0.8660375419135764, -1.789365922540813 },
		{ 0.1493933165684358, 0.8506066834321167, -1.754547928679208 },
		{ 0.04223050331532988, 0.9577694966846801, -1.950484218257796 },
		{ 0.04738222705817383, 0.9526177729445925, -1.943423167777977 },
		{ 0.05250655037757846, 0.9474934496231806, -1.936173869532924 },
		{ 0.05590713404247251, 0.9440928659594431, -1.931237993554001 },
		{ 0.06267234425014567, 0.9373276557526374, -1.921119432106049 },
		{ 0.06938877155837442, 0.9306112284426293, -1.910677020516647 },
		{ 0.07771674358161415, 0.92228325641951, -1.897174358961363 },
		{ 0.08267759122039448, 0.9173224087796253, -1.88883644405978 },
		{ 0.0925196756427077, 0.907480324357625, -1.871636437174008 },
		{ 0.1022561629226461, 0.8977438370788348, -1.853750398190039 },
		{ 0.1086889521259145, 0.891311047874609, -1.841452691402135 },
		{ 0.1214165782455891, 0.8785834217544403, -1.815979706018884 },
		{ 0.1339624580873561, 0.8660375419135764, -1.789365922540813 },
		{ 0.1493933165684358, 0.8506066834321167, -1.754547928679208 },
		{ 0.1585195983507839, 0.8414804016492542, -1.732856688975128 },
		{ 0.1764794609044175, 0.8235205390962201, -1.68774362522255 },
		{ 0.1940557392424181, 0.8059442607576286, -1.640424421493851 },
		{ 0.2055643559589464, 0.7944356440417476, -1.607712044079665 },
		{ 0.2280911710183143, 0.7719088289817406, -1.539649268784859 },
		{ 0.2499792214401426, 0.7500207785599436, -1.468310065380245 },
		{ 0.2764685068760308, 0.7235314931242184, -1.374967388452512 },
		{ 0.003919290271836576, 0.9960807097281631, -1.996019145897885 },
		{ 0.004408120260101564, 0.9955918797398985, -1.995513982204973 },
		{ 0.005222303865404294, 0.9947776961345957, -1.994668321207849 },
		{ 0.007336066513708314, 0.9926639334862916, -1.99244787142106 },
		{ 0.007823219707438548, 0.9921767802925616, -1.991931010387075 },
		{ 0.008796808995975706, 0.9912031910040245, -1.990892292178777 },
		{ 0.01041733527314638, 0.9895826647268539, -1.989146316370315 },
		{ 0.01461831515552326, 0.9853816848444767, -1.984520641687532 },
		{ 0.01558523664828609, 0.9844147633517137, -1.983435574456665 },
		{ 0.01751623414343931, 0.9824837658565605, -1.98124571288586 },
		{ 0.02072614967209857, 0.9792738503279012, -1.977537690880311 },
		{ 0.02902293517306048, 0.9709770648269396, -1.967558622279595 },
		{ 0.03092757369518973, 0.9690724263048105, -1.965186911663389 },
		{ 0.03472564982831124, 0.9652743501716891, -1.96036666002138 },
		{ 0.04102272606396738, 0.9589772739360324, -1.952106864909625 },
		{ 0.05720353958006127, 0.9427964604199386, -1.929329883127006 },
		{ 0.06089863257570743, 0.9391013674242924, -1.923810973960849 },
		{ 0.06824542890062368, 0.9317545710993764, -1.912482726290573 },
		{ 0.0803625880742162, 0.9196374119257839, -1.892754880771601 },
		{ 0.1111348342196352, 0.8888651657803648, -1.836675670890762 },
		{ 0.1180886217018235, 0.8819113782981763, -1.822787671753789 },
		{ 0.003919290271836576, 0.9960807097281631, -1.996019145897885 },
		{ 0.004896710353390803, 0.9951032896466093, -1.995007143542836 },
		{ 0.006523612934019088, 0.9934763870659811, -1.993305601107747 },
		{ 0.007336066513708314, 0.9926639334862916, -1.99244787142106 },
		{ 0.008796808995975706, 0.9912031910040245, -1.990892292178777 },
		{ 0.01041733527314638, 0.9895826647268539, -1.989146316370315 },
		{ 0.01171184851038153, 0.9882881514896186, -1.987736262780872 },
		{ 0.01558523664828609, 0.9844147633517137, -1.983435574456665 },
		{ 0.01944344385374317, 0.980556556146257, -1.979029618818238 },
		{ 0.02584021528595585, 0.9741597847140442, -1.971454267340247 },
		{ 0.02902293517306048, 0.9709770648269396, -1.967558622279595 },
		{ 0.03472564982831124, 0.9652743501716891, -1.96036666002138 },
		{ 0.04102272606396738, 0.9589772739360324, -1.952106864909625 },
		{ 0.04603079678847861, 0.9539692032115213, -1.945297418723222 },
		{ 0.06089863257570743, 0.9391013674242924, -1.923810973960849 },
		{ 0.07553474962374385, 0.9244652503762558, -1.900771889676646 },
		{ 0.09942313071785158, 0.9005768692821483, -1.85904470469991 },
		{ 0.1111348342196352, 0.8888651657803648, -1.836675670890762 },
		{ 0.1318334192354171, 0.8681665807645829, -1.793988571300012 },
		{ 0.1542670305864461, 0.8457329694135539, -1.743066602086797 },
		{ 0.1717958186931401, 0.8282041813068599, -1.699821259181141 },
		{ 0.0006542843320947731, 0.9993457156679052, -1.999344002755713 },
		{ 0.0007360397679240255, 0.9992639602320761, -1.999261792416313 },
		{ 0.001308140576202039, 0.9986918594237979, -1.998685010018692 },
		{ 0.001634908252796215, 0.9983650917472036, -1.998354391304873 },
		{ 0.002614569920637108, 0.997385430079363, -1.997358050414093 },
		{ 0.003484584108749885, 0.9965154158915226, -1.996466761915085 },
		{ 0.005222303865404294, 0.9947776961345957, -1.994668321207849 },
		{ 0.007823219707438548, 0.9921767802925616, -1.991931010387075 },
		{ 0.01041733527314638, 0.9895826647268539, -1.989146316370315 },
		{ 0.03092757369518973, 0.9690724263048105, -1.965186911663389 },
		{ 0.02072614967209857, 0.9792738503279012, -1.977537690880311 },
		{ 0.03850884019859235, 0.9614911598014076, -1.955444537170417 },
		{ 0.04102272606396738, 0.9589772739360324, -1.952106864909625 },
		{ 0.04603079678847861, 0.9539692032115213, -1.945297418723222 },
		{ 0.0803625880742162, 0.9196374119257839, -1.892754880771601 },
		{ 0.09942313071785158, 0.9005768692821483, -1.85904470469991 },
		{ 0.1542670305864461, 0.8457329694135539, -1.743066602086797 },
		{ 0.2002069348513126, 0.7997930651490724, -1.623111757284033 },
		{ 0.2847357444469325, 0.7152642555530675, -1.344241374651668 },
		{ 0.3950774372357292, 0.6049225627642709, -0.8599605129823242 },
		{ 0.3950774372357292, 0.6049225627642709, -0.8599605129823242 },
		{ 0.0006542843320947731, 0.9993457156679052, -1.999344002755713 },
		{ 0.0007360397679240255, 0.9992639602320761, -1.999261792416313 },
		{ 0.001308140576202039, 0.9986918594237979, -1.998685010018692 },
		{ 0.001634908252796215, 0.9983650917472036, -1.998354391304873 },
		{ 0.002614569920637108, 0.997385430079363, -1.997358050414093 },
		{ 0.003484584108749885, 0.9965154158915226, -1.996466761915085 },
		{ 0.005222303865404294, 0.9947776961345957, -1.994668321207849 },
		{ 0.007823219707438548, 0.9921767802925616, -1.991931010387075 },
		{ 0.01041733527314638, 0.9895826647268539, -1.989146316370315 },
		{ 0.03092757369518973, 0.9690724263048105, -1.965186911663389 },
		{ 0.02072614967209857, 0.9792738503279012, -1.977537690880311 },
		{ 0.03850884019859235, 0.9614911598014076, -1.955444537170417 },
		{ 0.04102272606396738, 0.9589772739360324, -1.952106864909625 },
		{ 0.04603079678847861, 0.9539692032115213, -1.945297418723222 },
		{ 0.0803625880742162, 0.9196374119257839, -1.892754880771601 },
		{ 0.09942313071785158, 0.9005768692821483, -1.85904470469991 },
		{ 0.1542670305864461, 0.8457329694135539, -1.743066602086797 },
		{ 0.2002069348513126, 0.7997930651490724, -1.623111757284033 },
		{ 0.2847357444469325, 0.7152642555530675, -1.344241374651668 },
		{ 0.3950774372357292, 0.6049225627642709, -0.8599605129823242 },
		{ 0.3950774372357292, 0.6049225627642709, -0.8599605129823242 }
	},
	.c_bpre4800080040 = {
		{ 6.741889316255812e-05, 0.9999966290604018, -1.999989356582936 },
		{ 7.584633956984349e-05, 0.9999962076957963, -1.999987003479853 },
		{ 8.427406089597575e-05, 0.9999957863150062, -1.99998442301144 },
		{ 8.989209813679111e-05, 0.9999955054054861, -1.99998257650726 },
		{ 0.000101128303403432, 0.9999949435866828, -1.99997858048562 },
		{ 0.0001123646379041221, 0.9999943817681954, -1.999974180447144 },
		{ 0.0001264101826990868, 0.9999936794955296, -1.999968112252078 },
		{ 0.0001348375590627274, 0.999993258132167, -1.999964168324223 },
		{ 0.0001516922633455545, 0.9999924153896121, -1.999955598521516 },
		{ 0.000168546720120516, 0.9999915726641294, -1.999946119851251 },
		{ 0.0001797831014623282, 0.9999910108475356, -1.999939295726274 },
		{ 0.0002022560954641019, 0.999989887198933, -1.999924435227911 },
		{ 0.0002247286445120284, 0.9999887635679549, -1.999907958918832 },
		{ 0.0002528197997391629, 0.9999873590146456, -1.99988509075297 },
		{ 0.0002696741373932364, 0.9999865162934245, -1.999870158017709 },
		{ 0.0003033833761745079, 0.9999848308367503, -1.999837565278329 },
		{ 0.0003370994592925451, 0.9999831453338304, -1.999801335502403 },
		{ 0.0003595659683915061, 0.9999820217431521, -1.999775164109266 },
		{ 0.0004045124654167214, 0.9999797745655833, -1.999717973983575 },
		{ 0.0004494564504173448, 0.9999775272294433, -1.999654316036963 },
		{ 0.000505636403578682, 0.999974718189086, -1.999565658186709 },
		{ 0.0001348375590627274, 0.999993258132167, -1.999964168324223 },
		{ 0.0001516922633455545, 0.9999924153896121, -1.999955598521516 },
		{ 0.000168546720120516, 0.9999915726641294, -1.999946119851251 },
		{ 0.0001797831014623282, 0.9999910108475356, -1.999939295726274 },
		{ 0.0002022560954641019, 0.999989887198933, -1.999924435227911 },
		{ 0.0002247286445120284, 0.9999887635679549, -1.999907958918832 },
		{ 0.0002528197997391629, 0.9999873590146456, -1.99988509075297 },
		{ 0.0002696741373932364, 0.9999865162934245, -1.999870158017709 },
		{ 0.0003033833761745079, 0.9999848308367503, -1.999837565278329 },
		{ 0.0003370994592925451, 0.9999831453338304, -1.999801335502403 },
		{ 0.0003595659683915061, 0.9999820217431521, -1.999775164109266 },
		{ 0.0004045124654167214, 0.9999797745655833, -1.999717973983575 },
		{ 0.0004494564504173448, 0.9999775272294433, -1.999654316036963 },
		{ 0.000505636403578682, 0.999974718189086, -1.999565658186709 },
		{ 0.0005393465284350811, 0.9999730327359353, -1.999507615180677 },
		{ 0.0006067688667788881, 0.9999696618381563, -1.99938062321804 },
		{ 0.0006741787047951173, 0.9999662911153596, -1.999239098032174 },
		{ 0.0007191254724018767, 0.9999640438095221, -1.999136663501871 },
		{ 0.0008090143383657826, 0.9999595493766165, -1.998912417707706 },
		{ 0.0008989028003182673, 0.9999550549639117, -1.998662329186203 },
		{ 0.001011260023752759, 0.9999494370173418, -1.998313385021214 },
		{ 0.0002696741373932364, 0.9999865162934245, -1.999870158017709 },
		{ 0.0003033833761745079, 0.9999848308367503, -1.999837565278329 },
		{ 0.0003370994592925451, 0.9999831453338304, -1.999801335502403 },
		{ 0.0003595659683915061, 0.9999820217431521, -1.999775164109266 },
		{ 0.0004045124654167214, 0.9999797745655833, -1.999717973983575 },
		{ 0.0004494564504173448, 0.9999775272294433, -1.999654316036963 },
		{ 0.000505636403578682, 0.999974718189086, -1.999565658186709 },
		{ 0.0005393465284350811, 0.9999730327359353, -1.999507615180677 },
		{ 0.0006067688667788881, 0.9999696618381563, -1.99938062321804 },
		{ 0.0006741787047951173, 0.9999662911153596, -1.999239098032174 },
		{ 0.0007191254724018767, 0.9999640438095221, -1.999136663501871 },
		{ 0.0008090143383657826, 0.9999595493766165, -1.998912417707706 },
		{ 0.0008989028003182673, 0.9999550549639117, -1.998662329186203 },
		{ 0.001011260023752759, 0.9999494370173418, -1.998313385021214 },
		{ 0.001078678512158576, 0.999946066199104, -1.998084637693308 },
		{ 0.001213504793402286, 0.9999393247603313, -1.997583565689144 },
		{ 0.001348334683783742, 0.9999325833670082, -1.997024388868957 },
		{ 0.001438220086341152, 0.9999280890755047, -1.996619326953319 },
		{ 0.001617989891254571, 0.9999191005530974, -1.995731772006121 },
		{ 0.001797758291966374, 0.9999101121114897, -1.994741015150643 },
		{ 0.002022468915177794, 0.9998988765912992, -1.993357510716077 },
		{ 0.0005393465284350811, 0.9999730327359353, -1.999507615180677 },
		{ 0.0006067688667788881, 0.9999696618381563, -1.99938062321804 },
		{ 0.0006741787047951173, 0.9999662911153596, -1.999239098032174 },
		{ 0.0007191254724018767, 0.9999640438095221, -1.999136663501871 },
		{ 0.0008090143383657826, 0.9999595493766165, -1.998912417707706 },
		{ 0.0008989028003182673, 0.9999550549639117, -1.998662329186203 },
		{ 0.001011260023752759, 0.9999494370173418, -1.998313385021214 },
		{ 0.001078678512158576, 0.999946066199104, -1.998084637693308 },
		{ 0.001213504793402286, 0.9999393247603313, -1.997583565689144 },
		{ 0.001348334683783742, 0.9999325833670082, -1.997024388868957 },
		{ 0.001438220086341152, 0.9999280890755047, -1.996619326953319 },
		{ 0.001617989891254571, 0.9999191005530974, -1.995731772006121 },
		{ 0.001797758291966374, 0.9999101121114897, -1.994741015150643 },
		{ 0.002022468915177794, 0.9998988765912992, -1.993357510716077 },
		{ 0.00215729066905558, 0.9998921354706697, -1.99245010970846 },
		{ 0.002426935957119016, 0.999878653202147, -1.990461452382025 },
		{ 0.002696577750516688, 0.9998651711154161, -1.988241214643809 },
		{ 0.00287633698508433, 0.9998561831585892, -1.986632528378406 },
		{ 0.003235850712438112, 0.9998382074873173, -1.983107070707714 },
		{ 0.003595368801182365, 0.9998202319756219, -1.979171417894074 },
		{ 0.004044756509205648, 0.9997977640629079, -1.973676581611369 },
		{ 0.001078678512158576, 0.999946066199104, -1.998084637693308 },
		{ 0.001213504793402286, 0.9999393247603313, -1.997583565689144 },
		{ 0.001348334683783742, 0.9999325833670082, -1.997024388868957 },
		{ 0.001438220086341152, 0.9999280890755047, -1.996619326953319 },
		{ 0.001617989891254571, 0.9999191005530974, -1.995731772006121 },
		{ 0.001797758291966374, 0.9999101121114897, -1.994741015150643 },
		{ 0.002022468915177794, 0.9998988765912992, -1.993357510716077 },
		{ 0.00215729066905558, 0.9998921354706697, -1.99245010970846 },
		{ 0.002426935957119016, 0.999878653202147, -1.990461452382025 },
		{ 0.002696577750516688, 0.9998651711154161, -1.988241214643809 },
		{ 0.00287633698508433, 0.9998561831585892, -1.986632528378406 },
		{ 0.003235850712438112, 0.9998382074873173, -1.983107070707714 },
		{ 0.003595368801182365, 0.9998202319756219, -1.979171417894074 },
		{ 0.004044756509205648, 0.9997977640629079, -1.973676581611369 },
		{ 0.004314348642984659, 0.9997842825760958, -1.970073168649486 },
		{ 0.004853609646331519, 0.9997573217836794, -1.96217968954901 },
		{ 0.005392810819886547, 0.9997303600824994, -1.953372672774855 },
		{ 0.005752278419598485, 0.9997123876547723, -1.946996675687237 },
		{ 0.006471236006722367, 0.9996764404971651, -1.93303696980115 },
		{ 0.007190091270033132, 0.9996404962677857, -1.917479036793694 },
		{ 0.008088670911428644, 0.9995955673896058, -1.895802885730205 },
		{ 0.00215729066905558, 0.9998921354706697, -1.99245010970846 },
		{ 0.002426935957119016, 0.999878653202147, -1.990461452382025 },
		{ 0.002696577750516688, 0.9998651711154161, -1.988241214643809 },
		{ 0.00287633698508433, 0.9998561831585892, -1.986632528378406 },
		{ 0.003235850712438112, 0.9998382074873173, -1.983107070707714 },
		{ 0.003595368801182365, 0.9998202319756219, -1.979171417894074 },
		{ 0.004044756509205648, 0.9997977640629079, -1.973676581611369 },
		{ 0.004314348642984659, 0.9997842825760958, -1.970073168649486 },
		{ 0.004853609646331519, 0.9997573217836794, -1.96217968954901 },
		{ 0.005392810819886547, 0.9997303600824994, -1.953372672774855 },
		{ 0.005752278419598485, 0.9997123876547723, -1.946996675687237 },
		{ 0.006471236006722367, 0.9996764404971651, -1.93303696980115 },
		{ 0.007190091270033132, 0.9996404962677857, -1.917479036793694 },
		{ 0.008088670911428644, 0.9995955673896058, -1.895802885730205 },
		{ 0.008627766605795038, 0.9995686116861983, -1.881619723307976 },
		{ 0.009705989082864503, 0.9995147008246232, -1.850633495752709 },
		{ 0.01078416752271004, 0.9994607928706833, -1.816204075246747 },
		{ 0.01150288094682849, 0.9994248563951007, -1.791370111561173 },
		{ 0.01294025408919679, 0.9993529873202697, -1.7372803355424 },
		{ 0.0143775476877058, 0.999281123413575, -1.677446278899434 },
		{ 0.01617400993114774, 0.9991912999798711, -1.594879009469418 },
		{ 0.004314348642984659, 0.9997842825760958, -1.970073168649486 },
		{ 0.004853609646331519, 0.9997573217836794, -1.96217968954901 },
		{ 0.005392810819886547, 0.9997303600824994, -1.953372672774855 },
		{ 0.005752278419598485, 0.9997123876547723, -1.946996675687237 },
		{ 0.006471236006722367, 0.9996764404971651, -1.93303696980115 },
		{ 0.007190091270033132, 0.9996404962677857, -1.917479036793694 },
		{ 0.008088670911428644, 0.9995955673896058, -1.895802885730205 },
		{ 0.008627766605795038, 0.9995686116861983, -1.881619723307976 },
		{ 0.009705989082864503, 0.9995147008246232, -1.850633495752709 },
		{ 0.01078416752271004, 0.9994607928706833, -1.816204075246747 },
		{ 0.01150288094682849, 0.9994248563951007, -1.791370111561173 },
		{ 0.01294025408919679, 0.9993529873202697, -1.7372803355424 },
		{ 0.0143775476877058, 0.999281123413575, -1.677446278899434 },
		{ 0.01617400993114774, 0.9991912999798711, -1.594879009469418 },
		{ 0.01725181129389478, 0.9991374094682743, -1.541355538462134 },
		{ 0.01940726785722807, 0.999029637164536, -1.42581490018609 },
		{ 0.02156243842060026, 0.998921878120177, -1.299677595419436 },
		{ 0.02299910802190652, 0.9988500452147322, -1.210159181998514 },
		{ 0.02587213566991095, 0.9987063932659472, -1.019436887068519 },
		{ 0.02874476203160667, 0.9985627619768025, -0.8152612295606293 },
		{ 0.0323349581473138, 0.9983832523218643, -0.545253700039921 },
		{ 0.0003926952264089372, 0.9999803652386795, -1.999733632624292 },
		{ 0.0004417815875680527, 0.9999779109206218, -1.999665642044278 },
		{ 0.0005235919217739191, 0.9999738204039116, -1.999535193095221 },
		{ 0.0007362972245106511, 0.9999631851387744, -1.999095818109109 },
		{ 0.0007853827423455941, 0.9999607308628827, -1.998973870971295 },
		{ 0.0008835534165783936, 0.9999558223291709, -1.998706858130959 },
		{ 0.001047170136106817, 0.9999476414931946, -1.998193347618217 },
		{ 0.001472567342348621, 0.9999263716328827, -1.996457719702605 },
		{ 0.001570734643389892, 0.9999214632678308, -1.995975075098674 },
		{ 0.001767067799835857, 0.9999116466100084, -1.994917460078951 },
		{ 0.002094285443954837, 0.9998952857278023, -1.992881371474502 },
		{ 0.002945026261957271, 0.999852748686902, -1.985990683275569 },
		{ 0.003141345926394343, 0.9998429327036802, -1.984073573855182 },
		{ 0.003533979473231413, 0.9998233010263384, -1.979872379268897 },
		{ 0.004188351586328258, 0.9997905824206837, -1.971785589237709 },
		{ 0.005889618864936651, 0.9997055190567532, -1.944453496384007 },
		{ 0.006282198450088183, 0.9996858900774956, -1.936862080675578 },
		{ 0.007067334495912772, 0.9996466332752042, -1.920248035519343 },
		{ 0.008375826058198584, 0.9995812086970903, -1.888357243864446 },
		{ 0.01177750334935649, 0.9994111248325322, -1.781488356760583 },
		{ 0.01256242359930215, 0.9993718788200348, -1.752062933301869 },
		{ 0.0003926952264089372, 0.9999803652386795, -1.999733632624292 },
		{ 0.0004908678282452066, 0.9999754566085878, -1.99958994230369 },
		{ 0.0006544877604075925, 0.9999672756119795, -1.999281936776925 },
		{ 0.0007362972245106511, 0.9999631851387744, -1.999095818109109 },
		{ 0.0008835534165783936, 0.9999558223291709, -1.998706858130959 },
		{ 0.001047170136106817, 0.9999476414931946, -1.998193347618217 },
		{ 0.00117806254794989, 0.9999410968726025, -1.997720912186379 },
		{ 0.001570734643389892, 0.9999214632678308, -1.995975075098674 },
		{ 0.001963399028795041, 0.9999018300485604, -1.993736800140014 },
		{ 0.002617822538175064, 0.9998691088730915, -1.988913616644928 },
		{ 0.002945026261957271, 0.999852748686902, -1.985990683275569 },
		{ 0.003533979473231413, 0.9998233010263384, -1.979872379268897 },
		{ 0.004188351586328258, 0.9997905824206837, -1.971785589237709 },
		{ 0.004711833858738784, 0.9997644083070633, -1.964343082741025 },
		{ 0.006282198450088183, 0.9996858900774956, -1.936862080675578 },
		{ 0.007852439710138137, 0.9996073780144933, -1.901739626892541 },
		{ 0.01046923443361375, 0.9994765382783193, -1.826612709207101 },
		{ 0.01177750334935649, 0.9994111248325322, -1.781488356760583 },
		{ 0.01413217163098552, 0.9992933914184505, -1.688059241646229 },
		{ 0.01674814439328707, 0.9991625927803356, -1.566730644092463 },
		{ 0.01884067606748866, 0.9990579661966257, -1.457250541754196 },
		{ 6.544973985505914e-05, 0.9999967275130072, -1.999989873636191 },
		{ 7.363094228386319e-05, 0.9999963184528859, -1.999987644018131 },
		{ 0.0001308992655307203, 0.9999934550367233, -1.999966039621294 },
		{ 0.0001636239480564454, 0.9999918188025971, -1.999948982306083 },
		{ 0.0002617976743329386, 0.9999869101162835, -1.999877249565034 },
		{ 0.0003490682583149231, 0.9999825468052472, -1.999787595306702 },
		{ 0.0005235919217739191, 0.9999738204039116, -1.999535193095221 },
		{ 0.0007853827423455941, 0.9999607308628827, -1.998973870971295 },
		{ 0.001047170136106817, 0.9999476414931946, -1.998193347618217 },
		{ 0.003141345926394343, 0.9998429327036802, -1.984073573855182 },
		{ 0.002094285443954837, 0.9998952857278023, -1.992881371474502 },
		{ 0.003926605310797174, 0.9998036697344601, -1.975182768076098 },
		{ 0.004188351586328258, 0.9997905824206837, -1.971785589237709 },
		{ 0.004711833858738784, 0.9997644083070633, -1.964343082741025 },
		{ 0.008375826058198584, 0.9995812086970903, -1.888357243864446 },
		{ 0.01046923443361375, 0.9994765382783193, -1.826612709207101 },
		{ 0.01674814439328707, 0.9991625927803356, -1.566730644092463 },
		{ 0.02232775965042603, 0.998883612358173, -1.252507410256469 },
		{ 0.03348226376954223, 0.9983258868115229, -0.4563194550179607 },
		{ 0.05020236987341902, 0.9974898815063291, 0.8504898266561812 },
		{ 0.05020236987341902, 0.9974898815063291, 0.8504898266561812 },
		{ 6.544973985505914e-05, 0.9999967275130072, -1.999989873636191 },
		{ 7.363094228386319e-05, 0.9999963184528859, -1.999987644018131 },
		{ 0.0001308992655307203, 0.9999934550367233, -1.999966039621294 },
		{ 0.0001636239480564454, 0.9999918188025971, -1.999948982306083 },
		{ 0.0002617976743329386, 0.9999869101162835, -1.999877249565034 },
		{ 0.0003490682583149231, 0.9999825468052472, -1.999787595306702 },
		{ 0.0005235919217739191, 0.9999738204039116, -1.999535193095221 },
		{ 0.0007853827423455941, 0.9999607308628827, -1.998973870971295 },
		{ 0.001047170136106817, 0.9999476414931946, -1.998193347618217 },
		{ 0.003141345926394343, 0.9998429327036802, -1.984073573855182 },
		{ 0.002094285443954837, 0.9998952857278023, -1.992881371474502 },
		{ 0.003926605310797174, 0.9998036697344601, -1.975182768076098 },
		{ 0.004188351586328258, 0.9997905824206837, -1.971785589237709 },
		{ 0.004711833858738784, 0.9997644083070633, -1.964343082741025 },
		{ 0.008375826058198584, 0.9995812086970903, -1.888357243864446 },
		{ 0.01046923443361375, 0.9994765382783193, -1.826612709207101 },
		{ 0.01674814439328707, 0.9991625927803356, -1.566730644092463 },
		{ 0.02232775965042603, 0.998883612358173, -1.252507410256469 },
		{ 0.03348226376954223, 0.9983258868115229, -0.4563194550179607 },
		{ 0.05020236987341902, 0.9974898815063291, 0.8504898266561812 },
		{ 0.05020236987341902, 0.9974898815063291, 0.8504898266561812 }
	},
	.c_bpre9600080040 = {
		{ 3.370947499610846e-05, 0.9999983145287805, -1.999996496407056 },
		{ 3.792320573806686e-05, 0.9999981038461004, -1.999995802788609 },
		{ 4.21370748398698e-05, 0.9999978931552836, -1.999995052324382 },
		{ 4.494609956863934e-05, 0.9999977527002178, -1.999994520469418 },
		{ 5.056421561339311e-05, 0.9999974717901455, -1.999993381005525 },
		{ 5.618239786649881e-05, 0.9999971908801518, -1.999992140536419 },
		{ 6.320519122057532e-05, 0.9999968397427712, -1.999990447911594 },
		{ 6.741889316255812e-05, 0.9999966290604018, -1.999989356582936 },
		{ 7.58462754896902e-05, 0.9999962076876151, -1.999987003431959 },
		{ 8.427353761214728e-05, 0.9999957863231872, -1.999984423063746 },
		{ 8.989175274199597e-05, 0.9999955054136673, -1.999982576562508 },
		{ 0.000101128303403432, 0.9999949435866828, -1.99997858048562 },
		{ 0.0001123646379041221, 0.9999943817681954, -1.999974180447144 },
		{ 0.0001264102993582191, 0.9999936794873485, -1.999968112177709 },
		{ 0.0001348375232329252, 0.9999932581239859, -1.999964168245442 },
		{ 0.0001516922633455545, 0.9999924153896121, -1.999955598521516 },
		{ 0.0001685504398628728, 0.9999915726314049, -1.999946119465526 },
		{ 0.0001797837922411107, 0.9999910108311736, -1.999939295521646 },
		{ 0.0002022572554032874, 0.9999898872316577, -1.999924435684233 },
		{ 0.0002247294877875485, 0.9999887635515926, -1.999907958667138 },
		{ 0.0002528197997391629, 0.9999873590146456, -1.99988509075297 },
		{ 6.741889316255812e-05, 0.9999966290604018, -1.999989356582936 },
		{ 7.58462754896902e-05, 0.9999962076876151, -1.999987003431959 },
		{ 8.427353761214728e-05, 0.9999957863231872, -1.999984423063746 },
		{ 8.989175274199597e-05, 0.9999955054136673, -1.999982576562508 },
		{ 0.000101128303403432, 0.9999949435866828, -1.99997858048562 },
		{ 0.0001123646379041221, 0.9999943817681954, -1.999974180447144 },
		{ 0.0001264102993582191, 0.9999936794873485, -1.999968112177709 },
		{ 0.0001348375232329252, 0.9999932581239859, -1.999964168245442 },
		{ 0.0001516922633455545, 0.9999924153896121, -1.999955598521516 },
		{ 0.0001685504398628728, 0.9999915726314049, -1.999946119465526 },
		{ 0.0001797837922411107, 0.9999910108311736, -1.999939295521646 },
		{ 0.0002022572554032874, 0.9999898872316577, -1.999924435684233 },
		{ 0.0002247294877875485, 0.9999887635515926, -1.999907958667138 },
		{ 0.0002528197997391629, 0.9999873590146456, -1.99988509075297 },
		{ 0.0002696750823302545, 0.9999865162770624, -1.999870157718951 },
		{ 0.000303386734449656, 0.999984830804026, -1.999837564610218 },
		{ 0.0003370921931803035, 0.9999831454156414, -1.999801337349165 },
		{ 0.0003595659683915061, 0.9999820217431521, -1.999775164109266 },
		{ 0.0004045112598982879, 0.9999797744837725, -1.999717971783861 },
		{ 0.0004494564504173448, 0.9999775272294433, -1.999654316036963 },
		{ 0.000505636403578682, 0.999974718189086, -1.999565658186709 },
		{ 0.0001348375232329252, 0.9999932581239859, -1.999964168245442 },
		{ 0.0001516922633455545, 0.9999924153896121, -1.999955598521516 },
		{ 0.0001685504398628728, 0.9999915726314049, -1.999946119465526 },
		{ 0.0001797837922411107, 0.9999910108311736, -1.999939295521646 },
		{ 0.0002022572554032874, 0.9999898872316577, -1.999924435684233 },
		{ 0.0002247294877875485, 0.9999887635515926, -1.999907958667138 },
		{ 0.0002528197997391629, 0.9999873590146456, -1.99988509075297 },
		{ 0.0002696750823302545, 0.9999865162770624, -1.999870157718951 },
		{ 0.000303386734449656, 0.999984830804026, -1.999837564610218 },
		{ 0.0003370921931803035, 0.9999831454156414, -1.999801337349165 },
		{ 0.0003595659683915061, 0.9999820217431521, -1.999775164109266 },
		{ 0.0004045112598982879, 0.9999797744837725, -1.999717971783861 },
		{ 0.0004494564504173448, 0.9999775272294433, -1.999654316036963 },
		{ 0.000505636403578682, 0.999974718189086, -1.999565658186709 },
		{ 0.0005393465284350811, 0.9999730327359353, -1.999507615180677 },
		{ 0.0006067616006974581, 0.9999696619199661, -1.999380626476514 },
		{ 0.0006741787047951173, 0.9999662911153596, -1.999239098032174 },
		{ 0.0007191229716023424, 0.9999640438913314, -1.999136667348446 },
		{ 0.0008090113081050348, 0.9999595494584255, -1.998912422024708 },
		{ 0.0008988993464831963, 0.9999550550457204, -1.998662333973574 },
		{ 0.001011260023752759, 0.9999494370173418, -1.998313385021214 },
		{ 0.0002696750823302545, 0.9999865162770624, -1.999870157718951 },
		{ 0.000303386734449656, 0.999984830804026, -1.999837564610218 },
		{ 0.0003370921931803035, 0.9999831454156414, -1.999801337349165 },
		{ 0.0003595659683915061, 0.9999820217431521, -1.999775164109266 },
		{ 0.0004045112598982879, 0.9999797744837725, -1.999717971783861 },
		{ 0.0004494564504173448, 0.9999775272294433, -1.999654316036963 },
		{ 0.000505636403578682, 0.999974718189086, -1.999565658186709 },
		{ 0.0005393465284350811, 0.9999730327359353, -1.999507615180677 },
		{ 0.0006067616006974581, 0.9999696619199661, -1.999380626476514 },
		{ 0.0006741787047951173, 0.9999662911153596, -1.999239098032174 },
		{ 0.0007191229716023424, 0.9999640438913314, -1.999136667348446 },
		{ 0.0008090113081050348, 0.9999595494584255, -1.998912422024708 },
		{ 0.0008988993464831963, 0.9999550550457204, -1.998662333973574 },
		{ 0.001011260023752759, 0.9999494370173418, -1.998313385021214 },
		{ 0.001078674422994282, 0.9999460662809119, -1.998084643421218 },
		{ 0.001213504793402286, 0.9999393247603313, -1.997583565689144 },
		{ 0.001348334325405725, 0.9999325832852012, -1.997024381730834 },
		{ 0.001438220204473437, 0.9999280889936981, -1.996619319345302 },
		{ 0.001617990803565711, 0.9999191004712918, -1.995731763458625 },
		{ 0.001797765199404069, 0.9999101119478799, -1.994740996177585 },
		{ 0.002022480514328806, 0.9998988769185153, -1.993357553354437 },
		{ 0.0005393465284350811, 0.9999730327359353, -1.999507615180677 },
		{ 0.0006067616006974581, 0.9999696619199661, -1.999380626476514 },
		{ 0.0006741787047951173, 0.9999662911153596, -1.999239098032174 },
		{ 0.0007191229716023424, 0.9999640438913314, -1.999136667348446 },
		{ 0.0008090113081050348, 0.9999595494584255, -1.998912422024708 },
		{ 0.0008988993464831963, 0.9999550550457204, -1.998662333973574 },
		{ 0.001011260023752759, 0.9999494370173418, -1.998313385021214 },
		{ 0.001078674422994282, 0.9999460662809119, -1.998084643421218 },
		{ 0.001213504793402286, 0.9999393247603313, -1.997583565689144 },
		{ 0.001348334325405725, 0.9999325832852012, -1.997024381730834 },
		{ 0.001438220204473437, 0.9999280889936981, -1.996619319345302 },
		{ 0.001617990803565711, 0.9999191004712918, -1.995731763458625 },
		{ 0.001797765199404069, 0.9999101119478799, -1.994740996177585 },
		{ 0.002022480514328806, 0.9998988769185153, -1.993357553354437 },
		{ 0.00215729066905558, 0.9998921354706697, -1.99245010970846 },
		{ 0.002426952074200755, 0.9998786535293566, -1.990461503457444 },
		{ 0.002696587199085923, 0.9998651709518135, -1.988241186297376 },
		{ 0.0028763460428273, 0.9998561834857915, -1.986632588812395 },
		{ 0.003235879774452211, 0.9998382071601211, -1.983107002800802 },
		{ 0.003595368801182365, 0.9998202319756219, -1.979171417894074 },
		{ 0.004044744453699411, 0.9997977632449505, -1.973676369945591 },
		{ 0.001078674422994282, 0.9999460662809119, -1.998084643421218 },
		{ 0.001213504793402286, 0.9999393247603313, -1.997583565689144 },
		{ 0.001348334325405725, 0.9999325832852012, -1.997024381730834 },
		{ 0.001438220204473437, 0.9999280889936981, -1.996619319345302 },
		{ 0.001617990803565711, 0.9999191004712918, -1.995731763458625 },
		{ 0.001797765199404069, 0.9999101119478799, -1.994740996177585 },
		{ 0.002022480514328806, 0.9998988769185153, -1.993357553354437 },
		{ 0.00215729066905558, 0.9998921354706697, -1.99245010970846 },
		{ 0.002426952074200755, 0.9998786535293566, -1.990461503457444 },
		{ 0.002696587199085923, 0.9998651709518135, -1.988241186297376 },
		{ 0.0028763460428273, 0.9998561834857915, -1.986632588812395 },
		{ 0.003235879774452211, 0.9998382071601211, -1.983107002800802 },
		{ 0.003595368801182365, 0.9998202319756219, -1.979171417894074 },
		{ 0.004044744453699411, 0.9997977632449505, -1.973676369945591 },
		{ 0.004314348642984659, 0.9997842825760958, -1.970073168649486 },
		{ 0.004853583472900288, 0.9997573209657549, -1.962179436207806 },
		{ 0.005392810819886547, 0.9997303600824994, -1.953372672774855 },
		{ 0.0057522676873645, 0.9997123868368845, -1.94699637635482 },
		{ 0.006471173946862368, 0.9996764413150236, -1.933037305649788 },
		{ 0.00719006626873355, 0.999640497085615, -1.9174794088785 },
		{ 0.00808864061728755, 0.9995955682073983, -1.895803302672451 },
		{ 0.00215729066905558, 0.9998921354706697, -1.99245010970846 },
		{ 0.002426952074200755, 0.9998786535293566, -1.990461503457444 },
		{ 0.002696587199085923, 0.9998651709518135, -1.988241186297376 },
		{ 0.0028763460428273, 0.9998561834857915, -1.986632588812395 },
		{ 0.003235879774452211, 0.9998382071601211, -1.983107002800802 },
		{ 0.003595368801182365, 0.9998202319756219, -1.979171417894074 },
		{ 0.004044744453699411, 0.9997977632449505, -1.973676369945591 },
		{ 0.004314348642984659, 0.9997842825760958, -1.970073168649486 },
		{ 0.004853583472900288, 0.9997573209657549, -1.962179436207806 },
		{ 0.005392810819886547, 0.9997303600824994, -1.953372672774855 },
		{ 0.0057522676873645, 0.9997123868368845, -1.94699637635482 },
		{ 0.006471173946862368, 0.9996764413150236, -1.933037305649788 },
		{ 0.00719006626873355, 0.999640497085615, -1.9174794088785 },
		{ 0.00808864061728755, 0.9995955682073983, -1.895803302672451 },
		{ 0.008627766605795038, 0.9995686116861983, -1.881619723307976 },
		{ 0.009705989082864503, 0.9995147008246232, -1.850633495752709 },
		{ 0.01078412664487205, 0.9994607936883653, -1.816204623286904 },
		{ 0.01150286190497959, 0.9994248572127533, -1.791370693542832 },
		{ 0.01294025408919679, 0.9993529873202697, -1.7372803355424 },
		{ 0.01437754886330276, 0.9992811225960403, -1.677445566252629 },
		{ 0.01617401904502654, 0.9991912991624099, -1.594878219847085 },
		{ 0.0001963485770216042, 0.999990182571149, -1.999928498163521 },
		{ 0.0002208920136107551, 0.9999889553993193, -1.999910886225415 },
		{ 0.0002617976743329386, 0.9999869101162835, -1.999877249565034 },
		{ 0.0003681520006541136, 0.9999815923999673, -1.999764736890097 },
		{ 0.0003926952264089372, 0.9999803652386795, -1.999733632624292 },
		{ 0.0004417815875680527, 0.9999779109206218, -1.999665642044278 },
		{ 0.0005235919217739191, 0.9999738204039116, -1.999535193095221 },
		{ 0.0007362972245106511, 0.9999631851387744, -1.999095818109109 },
		{ 0.0007853827423455941, 0.9999607308628827, -1.998973870971295 },
		{ 0.0008835534165783936, 0.9999558223291709, -1.998706858130959 },
		{ 0.001047170136106817, 0.9999476414931946, -1.998193347618217 },
		{ 0.001472567342348621, 0.9999263716328827, -1.996457719702605 },
		{ 0.001570734643389892, 0.9999214632678308, -1.995975075098674 },
		{ 0.001767067799835857, 0.9999116466100084, -1.994917460078951 },
		{ 0.002094285443954837, 0.9998952857278023, -1.992881371474502 },
		{ 0.002945026261957271, 0.999852748686902, -1.985990683275569 },
		{ 0.003141345926394343, 0.9998429327036802, -1.984073573855182 },
		{ 0.003533979473231413, 0.9998233010263384, -1.979872379268897 },
		{ 0.004188351586328258, 0.9997905824206837, -1.971785589237709 },
		{ 0.005889618864936651, 0.9997055190567532, -1.944453496384007 },
		{ 0.006282198450088183, 0.9996858900774956, -1.936862080675578 },
		{ 0.0001963485770216042, 0.999990182571149, -1.999928498163521 },
		{ 0.000245435420091438, 0.9999877282289955, -1.999891346739041 },
		{ 0.0003272465574614608, 0.9999836376721271, -1.999812294221941 },
		{ 0.0003681520006541136, 0.9999815923999673, -1.999764736890097 },
		{ 0.0004417815875680527, 0.9999779109206218, -1.999665642044278 },
		{ 0.0005235919217739191, 0.9999738204039116, -1.999535193095221 },
		{ 0.0005890399481722783, 0.9999705480025913, -1.999415416613577 },
		{ 0.0007853827423455941, 0.9999607308628827, -1.998973870971295 },
		{ 0.0009817236089197298, 0.9999509138195537, -1.998409024144666 },
		{ 0.001308954103101908, 0.9999345522948448, -1.997193711497798 },
		{ 0.001472567342348621, 0.9999263716328827, -1.996457719702605 },
		{ 0.001767067799835857, 0.9999116466100084, -1.994917460078951 },
		{ 0.002094285443954837, 0.9998952857278023, -1.992881371474502 },
		{ 0.002356055704332025, 0.9998821972147836, -1.991006649233875 },
		{ 0.003141345926394343, 0.9998429327036802, -1.984073573855182 },
		{ 0.003926605310797174, 0.9998036697344601, -1.975182768076098 },
		{ 0.005235302426596641, 0.9997382348786703, -1.956039156542228 },
		{ 0.005889618864936651, 0.9997055190567532, -1.944453496384007 },
		{ 0.007067334495912772, 0.9996466332752042, -1.920248035519343 },
		{ 0.008375826058198584, 0.9995812086970903, -1.888357243864446 },
		{ 0.009422557648564631, 0.9995288721175721, -1.859114928149579 },
		{ 3.272489670228179e-05, 0.9999983637551649, -1.999996650283825 },
		{ 3.68155050222356e-05, 0.9999981592247488, -1.999995990612888 },
		{ 6.544973985505914e-05, 0.9999967275130072, -1.999989873636191 },
		{ 8.181214135967154e-05, 0.9999959093929321, -1.999985200218229 },
		{ 0.0001308992655307203, 0.9999934550367233, -1.999966039621294 },
		{ 0.0001745348907198383, 0.9999912733645464, -1.999942534683384 },
		{ 0.0002617976743329386, 0.9999869101162835, -1.999877249565034 },
		{ 0.0003926952264089372, 0.9999803652386795, -1.999733632624292 },
		{ 0.0005235919217739191, 0.9999738204039116, -1.999535193095221 },
		{ 0.001570734643389892, 0.9999214632678308, -1.995975075098674 },
		{ 0.001047170136106817, 0.9999476414931946, -1.998193347618217 },
		{ 0.001963399028795041, 0.9999018300485604, -1.993736800140014 },
		{ 0.002094285443954837, 0.9998952857278023, -1.992881371474502 },
		{ 0.002356055704332025, 0.9998821972147836, -1.991006649233875 },
		{ 0.004188351586328258, 0.9997905824206837, -1.971785589237709 },
		{ 0.005235302426596641, 0.9997382348786703, -1.956039156542228 },
		{ 0.008375826058198584, 0.9995812086970903, -1.888357243864446 },
		{ 0.01116699737002131, 0.9994416503018937, -1.803161326410995 },
		{ 0.01674814439328707, 0.9991625927803356, -1.566730644092463 },
		{ 0.02511695647427736, 0.9987441521762863, -1.070980673043587 },
		{ 0.02511695647427736, 0.9987441521762863, -1.070980673043587 },
		{ 3.272489670228179e-05, 0.9999983637551649, -1.999996650283825 },
		{ 3.68155050222356e-05, 0.9999981592247488, -1.999995990612888 },
		{ 6.544973985505914e-05, 0.9999967275130072, -1.999989873636191 },
		{ 8.181214135967154e-05, 0.9999959093929321, -1.999985200218229 },
		{ 0.0001308992655307203, 0.9999934550367233, -1.999966039621294 },
		{ 0.0001745348907198383, 0.9999912733645464, -1.999942534683384 },
		{ 0.0002617976743329386, 0.9999869101162835, -1.999877249565034 },
		{ 0.0003926952264089372, 0.9999803652386795, -1.999733632624292 },
		{ 0.0005235919217739191, 0.9999738204039116, -1.999535193095221 },
		{ 0.001570734643389892, 0.9999214632678308, -1.995975075098674 },
		{ 0.001047170136106817, 0.9999476414931946, -1.998193347618217 },
		{ 0.001963399028795041, 0.9999018300485604, -1.993736800140014 },
		{ 0.002094285443954837, 0.9998952857278023, -1.992881371474502 },
		{ 0.002356055704332025, 0.9998821972147836, -1.991006649233875 },
		{ 0.004188351586328258, 0.9997905824206837, -1.971785589237709 },
		{ 0.005235302426596641, 0.9997382348786703, -1.956039156542228 },
		{ 0.008375826058198584, 0.9995812086970903, -1.888357243864446 },
		{ 0.01116699737002131, 0.9994416503018937, -1.803161326410995 },
		{ 0.01674814439328707, 0.9991625927803356, -1.566730644092463 },
		{ 0.02511695647427736, 0.9987441521762863, -1.070980673043587 },
		{ 0.02511695647427736, 0.9987441521762863, -1.070980673043587 }
	}
};
